package s.d.manager.dialogs;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.events.ShellListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;
import s.d.manager.model.Request;
import s.d.manager.model.Settings;

public class DialogBatteryTest {
	private Shell dialog;
	private Settings settings = new Settings();
	private Label test;
	private Label testResult;
	private Job job;
	private Label state;
	private Button startTestBtn;
	private Gui gui = new Gui();
	private Label password;
	
	public DialogBatteryTest() {
		
		createControls();
	}
	
	public void open() {
		/*dialog.setText(Application.messages.DialogBatteryTitle);
		password.setText(Application.messages.DialogBatteryInputPassword);
		startTestBtn.setText(Application.messages.DialogBatteryRunTest);
		*/
		dialog.open();
	}
	
	public void stop() {
    	if (job != null){
    		if (job.getState() != 0){
	    		job.cancel();
				if (!job.cancel()){
					try {
						job.join();
					} catch (InterruptedException e) {
						e.printStackTrace();
					}		
				}
			}
    	}
	}
	//@PostConstruct
	protected void createControls() {
			//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
			//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
			dialog = gui.createOsSpecificDialog();
			dialog.setSize(390, 160);
		    dialog.setText(Application.getInstance().messages.DialogBatteryTitle);
		    
		    GridLayout gridLayout = new GridLayout();
			gridLayout.numColumns = 2;
			GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
			gridData.minimumWidth = 50;
			gridData.horizontalSpan= 1;
		    dialog.setLayout(gridLayout);
		    
		    dialog.addListener(SWT.Traverse, new Listener() {
		        public void handleEvent(Event event) {
		          switch (event.detail) {
		          case SWT.TRAVERSE_ESCAPE:
		            dialog.dispose();
		            event.detail = SWT.TRAVERSE_NONE;
		            event.doit = false;
		            break;
		          }
		        }
		      });
		    
		    state = new Label(dialog, SWT.NONE);
		    
		    GridData gridDataCenter = new GridData(SWT.FILL, SWT.FILL, true, false);
		    gridDataCenter.horizontalSpan= 2;
		    //gridDataCenter.horizontalAlignment = SWT.CENTER;
			
		    state.setLayoutData(gridDataCenter);
		    state.pack();
		    password = new Label(dialog, SWT.NONE);
		    
		    password.setText(Application.getInstance().messages.DialogBatteryInputPassword);
		    final Text  passwordText = new Text(dialog, SWT.BORDER);
		    passwordText.setTextLimit(gui.maxPswLenght);
		    passwordText.addListener(SWT.Verify, gui.getPswListener());
		    passwordText.setLayoutData(gridData);
		    
		    settings.read();
		    //passwordText.setText(settings.password);
		   
		    startTestBtn = new Button(dialog, SWT.PUSH);
		   
		    startTestBtn.setText(Application.getInstance().messages.DialogBatteryRunTest);
		    GridData gridData1 = new GridData(SWT.FILL, SWT.FILL, true, false);
		    gridData1.horizontalSpan= 2;
		    startTestBtn.setLayoutData(gridData1);
		  
		    startTestBtn.addSelectionListener(new SelectionAdapter() {
				@Override
				public void widgetSelected(SelectionEvent e) {
					Request request = new Request();
					request.setPasswordToWork(passwordText.getText());
					//System.out.println(request.openAccess());
					if (request.openAccess() != false) {
						state.setText(Application.getInstance().messages.DialogBatteryAccessOpen);
						state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_DARK_GREEN));
						
						if (request.startBatteryTest()){
							timerJobRun(request);
						} else {
							testResult.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));
							setLabelValue(getTestResultLabel(), Application.getInstance().messages.DialogBatteryCantStartTest);
						}	
					} else {
						if (request.getStatusAccess() != null){
							if (request.getStatusAccess() == 0){
								state.setText(Application.getInstance().messages.DialogBatteryWrongPassword);
								state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));	
							}
						} else {
							state.setText(Application.getInstance().messages.DialogBatteryNoConnection);
							state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));
						}
						
					}
					request.closeAccess();
					//dialog.pack();
				}
			});
		    
		    passwordText.addKeyListener(new KeyAdapter() {	
		    	public void keyPressed(KeyEvent e) {
		    		if(e.keyCode == SWT.CR) {
		    			startTestBtn.notifyListeners(SWT.Selection, new Event());
		    		}
		    	}
		    });
		    
		    dialog.addShellListener(new ShellListener(){

				@Override
				public void shellClosed(ShellEvent e) {
					stop();
					dialog.dispose();
					
				
					// TODO Auto-generated method stub
					
				}
				@Override
				public void shellIconified(ShellEvent e) {
					// TODO Auto-generated method stub
					
				}
				@Override
				public void shellActivated(ShellEvent e) {
					// TODO Auto-generated method stub
					
				}
				
				@Override
				public void shellDeactivated(ShellEvent e) {
					// TODO Auto-generated method stub
					
				}
				@Override
				public void shellDeiconified(ShellEvent e) {
					// TODO Auto-generated method stub
					
				}
			});
		    
		    test = new Label(dialog, SWT.NONE);
		    test.setText(Application.getInstance().messages.DialogBatteryTestResultLbl);
		    testResult = new Label(dialog, SWT.NONE);
		 
		    dialog.pack();
		    gui.centerShell(dialog);
		    dialog.open();
	}
	
	private void timerJobRun(final Request request){ //  ,    
		job = new Job("First1 Job") {
			 @Override
		     	protected IStatus run(IProgressMonitor monitor) {
				 	runTimer(request);
				 	if (monitor.isCanceled()) return Status.CANCEL_STATUS;
				 	return Status.OK_STATUS;
		      }

		 };
		 	job.setUser(true);
		    job.schedule();
	}
	
	private void runTimer(Request request){ //   
		for (int i=10; i>=0; i--) {
			syncWithUi(request, i);
			try {Thread.sleep(1000);} catch (Throwable e) {}
		}
	}
	
	private void syncWithUi(final Request request, final int i){//    
		
		Display.getDefault().asyncExec(new Runnable() {
	          public void run() {
	        	  if (dialog.isDisposed() != true){ 
	        		  startTestBtn.setEnabled(false);
		        	  if (i == 0){
		        		  startTestBtn.setEnabled(true);
							//setLabelValue(getTestResultLabel(), " ");		        		  		
								if (request.getBatteryTestResult() != null){
								if (request.getBatteryTestResult() == 1){
									testResult.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));
									setLabelValue(getTestResultLabel(), Application.getInstance().messages.DialogBatteryTestResultProblem);
								}
								if (request.getBatteryTestResult() == 0){
									testResult.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_DARK_GREEN));
									setLabelValue(getTestResultLabel(), Application.getInstance().messages.DialogBatteryTestResultOk);
								}
							}else{
								testResult.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));
								testResult.setText(Application.getInstance().messages.DialogBatteryCantStartTest);
							}
		        	  } else {
		        		  //getStateLabel().setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_BLACK));
		        		  getTestResultLabel().setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_BLACK));
		        		  setLabelValue(getTestResultLabel()," "+String.valueOf(i)+" c.");
		        	  }
		        	  dialog.pack ();
	        	  }
	          }
		});
		
	}
	
	public Label getTestResultLabel(){
		return testResult;
	}
	
	public Label getStateLabel(){
		return state;
	}
	
	public void setLabelValue(Label label, String value){
		label.setText(value);
		label.pack();
	}
	
	/*public void centerShell(){
		Monitor primary = Display.getDefault().getPrimaryMonitor();
	    Rectangle bounds = primary.getBounds();
	    Rectangle rect = Application.getInstance().shell.getBounds();
	    int x = bounds.x + (bounds.width - rect.width) / 2;
	    int y = bounds.y + (bounds.height - rect.height) / 2;
	    Application.getInstance().shell.setLocation(x, y);
	    Application.getInstance().shell.open();

	}*/
}
