package s.d.manager.dialogs;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;
import s.d.manager.model.Request;
import s.d.manager.model.ups.ClimatControlUnit;

public class DialogClimaticSettings {

	private Request request;
	private Shell dialog;
	private Gui gui = new Gui();
	private Table table;
	private String password;
	
	public DialogClimaticSettings(String password) {
		this.password = password;
		createControls();
	}
	
	private void setRequest() {
		Request request = new Request();
		this.request = request;
	}
	
	private Request getRequest() {
		return request;
	}
	
	protected void createControls() {
		setRequest();
		getRequest().extractRelays();
		//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
		//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
		dialog = gui.createOsSpecificDialog();
		dialog.setSize(500, 200);
		
		dialog.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event event) {
				getRequest().closeAccess();
				dialog.dispose();
			}
		});
		
		dialog.setText("  ");
		
		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
		gridData.horizontalSpan = 2;
		gridData.verticalSpan = 1;

		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		
		dialog.setLayout(gridLayout);
		
		Label currentState = new Label(dialog, SWT.NONE);  
		currentState.setText(Application.getInstance().messages.DialogCCCurrentValues);
		currentState.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2,1));
		
		gui.setComposite(dialog);
		table = gui.createTable("", "");
		table.setLayout(gridLayout);
		table.setLayoutData(gridData);
		Button climaticSetButton = new Button(dialog, SWT.PUSH);
		getRequest().extractClimatControlUnitPresense();
		try {
			gui.fillClimatControlUnitTable(getRequest().getUps().getClimatControl().getClimatControlUnitList(), table);
		} catch (Exception e) {
			currentState.setText("     ");
			currentState.setForeground(Display.getDefault().getSystemColor(SWT.COLOR_RED));
			currentState.pack();
			climaticSetButton.setEnabled(false);
		}
		 
		climaticSetButton.setText(Application.getInstance().messages.DialogCCApplyButton);
		climaticSetButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				List<ClimatControlUnit> climatControlUnitNew = new ArrayList<ClimatControlUnit>();
				for (TableItem item : table.getItems()) {
					ClimatControlUnit unit = (ClimatControlUnit) item.getData();
					climatControlUnitNew.add(unit);
				}
				getRequest().setPasswordToWork(password);
				getRequest().openAccess();
				getRequest().setClimatControlUnitValues(climatControlUnitNew);
				getRequest().closeAccess();
				gui.clearTable(table);
				getRequest().extractClimatControlUnitPresense();
				gui.fillClimatControlUnitTable(getRequest().getUps().getClimatControl().getClimatControlUnitList(), table);
			}
		});
		dialog.pack();
		gui.centerShell(dialog);
		dialog.open();
		
		 /*dialog.addShellListener(new ShellListener(){

				@Override
				public void shellClosed(ShellEvent e) {
					try {
						getRequest().closeAccess();
						
					} catch (Exception e1) {
						
					}
					// TODO Auto-generated method stub
					
				}
				@Override
				public void shellIconified(ShellEvent e) {
					// TODO Auto-generated method stub
					
				}
				@Override
				public void shellActivated(ShellEvent e) {
					// TODO Auto-generated method stub
					
				}
				
				@Override
				public void shellDeactivated(ShellEvent e) {
					// TODO Auto-generated method stub
					
				}
				@Override
				public void shellDeiconified(ShellEvent e) {
					// TODO Auto-generated method stub
					
				}
			});*/
		}
}
