package s.d.manager.dialogs;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.events.ShellListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;
import s.d.manager.model.Request;
import s.d.manager.model.Settings;
import s.d.manager.model.ups.Relay;

public class DialogControlContacts {

	private Shell dialog;
	final Settings settings = new Settings();
	private Table table;

	private String password;

	private Request request;
	private Gui gui = new Gui();
	
	public DialogControlContacts(String password) {
		this.password = password;
		createControls();
		
	}
	
	private void setRequest() {
		Request request = new Request();
		this.request = request;
	}

	public Request getRequest() {
		return request;
	}
	
	protected void createControls() {
			setRequest();
			getRequest().extractRelays();
			//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
			//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
			dialog = gui.createOsSpecificDialog();
			dialog.setSize(500, 200);
			
			dialog.addListener(SWT.Close, new Listener() {
				public void handleEvent(Event event) {
					getRequest().closeAccess();
					
					dialog.dispose();
				}
			});
			
			dialog.setText(Application.getInstance().messages.RelayButton);
			
			GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
			gridData.horizontalSpan = 2;
			gridData.verticalSpan = 1;
	
			GridLayout gridLayout = new GridLayout();
			gridLayout.numColumns = 2;
			
			dialog.setLayout(gridLayout);
			
			Label currentState = new Label(dialog, SWT.NONE);  
			currentState.setText(Application.getInstance().messages.DialogCCCurrentValues);
			currentState.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2,1));
			
			gui.setComposite(dialog);
			table = gui.createTable(Application.getInstance().messages.DialogCCNumber, Application.getInstance().messages.DialogCCAssigment, Application.getInstance().messages.DialogCCPolarity);
			table.setLayout(gridLayout);
			table.setLayoutData(gridData);
			Button controlContactsButton = new Button(dialog, SWT.PUSH);
			gui.fillRelaysTable(getRequest().getUps().getRelays(), table);
			
			if (getRequest().getUps().getRelays() == null) {
				currentState.setText("     ");
				currentState.setForeground(Display.getDefault().getSystemColor(SWT.COLOR_RED));
				currentState.pack();
				controlContactsButton.setEnabled(false);
			}
			 
			controlContactsButton.setText(Application.getInstance().messages.DialogCCApplyButton);
			controlContactsButton.addSelectionListener(new SelectionAdapter() {
				@Override
				public void widgetSelected(SelectionEvent e) {
					List<Relay> relaysNew = new ArrayList<Relay>();
					for (TableItem item : table.getItems()) {
						Relay relay = (Relay) item.getData();
						relaysNew.add(relay);
					}
					getRequest().setPasswordToWork(password);
					getRequest().openAccess();
					getRequest().setRelaysValues(relaysNew);
					getRequest().closeAccess();
					gui.clearTable(table);
					getRequest().extractRelays();
					gui.fillRelaysTable(getRequest().getUps().getRelays(), table);
				}
			});
			dialog.pack();
			gui.centerShell(dialog);
			dialog.open();
			
			 dialog.addShellListener(new ShellListener(){

					@Override
					public void shellClosed(ShellEvent e) {
						try {
							getRequest().closeAccess();
							
						} catch (Exception e1) {
							
						}
						// TODO Auto-generated method stub
						
					}
					@Override
					public void shellIconified(ShellEvent e) {
						// TODO Auto-generated method stub
						
					}
					@Override
					public void shellActivated(ShellEvent e) {
						// TODO Auto-generated method stub
						
					}
					
					@Override
					public void shellDeactivated(ShellEvent e) {
						// TODO Auto-generated method stub
						
					}
					@Override
					public void shellDeiconified(ShellEvent e) {
						// TODO Auto-generated method stub
						
					}
				});
	}
	
}
