package s.d.manager.dialogs;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;
import s.d.manager.model.Request;
import s.d.manager.model.Settings;
import s.d.manager.model.ups.Relay;

public class DialogControlContactsLinux {
	
	private Shell dialog;
	final Settings settings = new Settings();
	//private Table table;

	private String password;

	private Request request;
	private Gui gui = new Gui();
	private Combo assigmentCombo1;
	private Combo polarityCombo1;
	
	private Combo assigmentCombo2;
	private Combo polarityCombo2;
	private Label currentState;
	private Button controlContactsButton;
	
	public DialogControlContactsLinux(String password) {
		this.password = password;
		createControls();
	}
	
	public void createControls() {
		setRequest();
		getRequest().extractRelays();
		//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
		//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
		dialog = gui.createOsSpecificDialog();
		dialog.setSize(500, 200);
		
		dialog.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event event) {
				getRequest().closeAccess();
				
				dialog.dispose();
			}
		});
		
		dialog.setText(Application.getInstance().messages.RelayButton);
		
		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
		gridData.horizontalSpan = 2;
		gridData.verticalSpan = 1;

		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		
		dialog.setLayout(gridLayout);
		
		currentState = new Label(dialog, SWT.NONE);
		currentState.setText(Application.getInstance().messages.DialogCCCurrentValues);
		currentState.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2,1));
		
		Label assigment = new Label(dialog, SWT.NONE);
		assigment.setText(Application.getInstance().messages.DialogCCAssigment);
		assigment.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		
		Label polarity = new Label(dialog, SWT.NONE);
		polarity.setText(Application.getInstance().messages.DialogCCPolarity);
		polarity.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		
		assigmentCombo1 = new Combo(dialog, SWT.NONE);
		assigmentCombo1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		assigmentCombo1.setItems(new String[] {Application.getInstance().messages.RelayCcAlarm, Application.getInstance().messages.RelayCcNoInputVoltage,
				Application.getInstance().messages.RelayCcLowBatteryDischarge, Application.getInstance().messages.RelayCcBatteryProblem,
				Application.getInstance().messages.RelayCcOnBypassSwitching, Application.getInstance().messages.RelayCcOverload,
				Application.getInstance().messages.RelayCcNormalMode, Application.getInstance().messages.ePo,
				Application.getInstance().messages.batteryDischarge}); 
	
		polarityCombo1 = new Combo(dialog, SWT.NONE);
		polarityCombo1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		polarityCombo1.setItems(new String[] {Application.getInstance().messages.RelayCcPolarityOpen, Application.getInstance().messages.RelayCcPolarityClose}); 
		
		assigmentCombo2 = new Combo(dialog, SWT.NONE);
		assigmentCombo2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		assigmentCombo2.setItems(new String[] {Application.getInstance().messages.RelayCcAlarm, Application.getInstance().messages.RelayCcNoInputVoltage,
				Application.getInstance().messages.RelayCcLowBatteryDischarge, Application.getInstance().messages.RelayCcBatteryProblem,
				Application.getInstance().messages.RelayCcOnBypassSwitching, Application.getInstance().messages.RelayCcOverload,
				Application.getInstance().messages.RelayCcNormalMode, Application.getInstance().messages.ePo,
				Application.getInstance().messages.batteryDischarge}); 
	
		polarityCombo2 = new Combo(dialog, SWT.NONE);
		polarityCombo2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		polarityCombo2.setItems(new String[] {Application.getInstance().messages.RelayCcPolarityOpen, Application.getInstance().messages.RelayCcPolarityClose}); 
		
		
		controlContactsButton = new Button(dialog, SWT.PUSH);
		fillCombos(getRequest().getUps().getRelays());
		 
		controlContactsButton.setText(Application.getInstance().messages.DialogCCApplyButton);
		controlContactsButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				List<Relay> relaysNew = new ArrayList<Relay>();
				Relay relay = new Relay();
				relay.setAssigment(assigmentCombo1.getSelectionIndex());
				relay.setPolarity(polarityCombo1.getSelectionIndex());
				relaysNew.add(relay);
				relay = new Relay();
				relay.setAssigment(assigmentCombo2.getSelectionIndex());
				relay.setPolarity(polarityCombo2.getSelectionIndex());
				relaysNew.add(relay);
				getRequest().setPasswordToWork(password);
				getRequest().openAccess();
				getRequest().setRelaysValues(relaysNew);
				getRequest().closeAccess();
				getRequest().extractRelays();
				fillCombos(getRequest().getUps().getRelays());
			}
		});
		dialog.pack();
		gui.centerShell(dialog);
		dialog.open();
		
		dialog.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event event) {
				getRequest().closeAccess();
				dialog.dispose();
			}
		});
	}
	
	private void setRequest() {
		Request request = new Request();
		this.request = request;
	}

	public Request getRequest() {
		return request;
	}
	
	private void fillCombos(List<Relay> relays) {
		try {
			if (!relays.isEmpty()) {
				assigmentCombo1.select(relays.get(0).getAssigment());
				polarityCombo1.select(relays.get(0).getPolarity());
				
				assigmentCombo2.select(relays.get(1).getAssigment());
				polarityCombo2.select(relays.get(1).getPolarity());
			}
		} catch (Exception e) {
			currentState.setText("     ");
			currentState.setForeground(Display.getDefault().getSystemColor(SWT.COLOR_RED));
			currentState.pack();
			controlContactsButton.setEnabled(false);
		}
	}
}
