package s.d.manager.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;
import s.d.manager.model.Request;

public class DialogOpenAccess {
	
	private Shell dialog;
	private boolean accessIsOpened;
	private boolean noConnection;
	private boolean isClosed;
	private Gui gui = new Gui();
	
	/*private final int controlContats = 0;
	private final int climatControlSettings = 1;*/
	
	public DialogOpenAccess() {
		
	}
	
	public void openToGetAccess() {
		createControlsOpenAccess();
	}
	
	public void openToSetControlContacts() {
		createControls(0);
		
	}
	
	public void openToSetClimaticSettings() {
		createControls(1);
		
	}
	
	protected void createControls(final int type) {
			//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
			//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
			dialog = gui.createOsSpecificDialog();
			dialog.setSize(370, 130);
		    dialog.setText(Application.getInstance().messages.DialogOpenAccessName);
		  
		    dialog.addListener(SWT.Close, new Listener() {
				public void handleEvent(Event event) {
					dialog.dispose();
				}
			});
		    
		    dialog.addListener(SWT.Traverse, new Listener() {
		        public void handleEvent(Event event) {
		          switch (event.detail) {
		          case SWT.TRAVERSE_ESCAPE:
		            dialog.dispose();
		            event.detail = SWT.TRAVERSE_NONE;
		            event.doit = false;
		            break;
		          }
		        }
		      });
		    
		    GridLayout gridLayout = new GridLayout();
			gridLayout.numColumns = 2;
			
			GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
			gridData.horizontalSpan= 1;
		    gridData.minimumWidth = 50;
			
			dialog.setLayout(gridLayout);
		    
			final Label state = new Label(dialog, SWT.NONE);
		    state.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2,1));
			
		    final Label password = new Label(dialog, SWT.NONE);
		    
		    password.setText(Application.getInstance().messages.DialogOpenAccessEnterPwdLbl);
		    final Text  passwordText = new Text(dialog, SWT.BORDER);
		    passwordText.setLayoutData(gridData);
		    passwordText.setTextLimit(gui.maxPswLenght);
		    passwordText.addListener(SWT.Verify, gui.getPswListener());
		    
		    final Button okButton = new Button(dialog, SWT.PUSH);
		    //okButton.setFocus();
		    
		    okButton.setText("&OK");
		    
		    okButton.setLayoutData(gridData);
		   
		    okButton.addSelectionListener(new SelectionAdapter() {
				@Override
				public void widgetSelected(SelectionEvent e) {
					Request request = new Request();
					request.setPasswordToWork(passwordText.getText());
					request.tryConnectToUps();
					if (!request.isFailed()) {
						if (request.openAccess() != false) {
							state.setText(Application.getInstance().messages.DialogOpenAccessIsOpened);
							state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_DARK_GREEN));
							//DialogControlContacts dc = new DialogControlContacts(passwordText.getText());
							switch (type){
								case 0: String operatingSystem = System.getProperty("os.name");   
							    		if (operatingSystem.contains("Linux")) {
							    			new DialogControlContactsLinux(passwordText.getText());							    			    
							    		}
							    		else if (operatingSystem.contains("Windows")) {
							    			new DialogControlContacts(passwordText.getText());
							    		} 
									break;
								case 1: new DialogClimaticSettings(passwordText.getText());
									break;
							}
							dialog.close();
						} else {
							if (request.getStatusAccess() == null) {
								state.setText(Application.getInstance().messages.DialogOpenAccessNoConnection);
								state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));
								return;
							}
							if (request.getStatusAccess() == 0) {
								state.setText(Application.getInstance().messages.DialogOpenAccessPwdIncorrect);
								state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));	
							}
						}	
					} else {
							state.setText(Application.getInstance().messages.DialogOpenAccessNoConnection);
							state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));
					}
				}
			});

		    passwordText.addKeyListener(new KeyAdapter() {	
		    	public void keyPressed(KeyEvent e) {
		    		if(e.keyCode == SWT.CR) {
		    			okButton.notifyListeners(SWT.Selection, new Event());
		    		}
		    	}
		    });
		    
		    dialog.pack();
		    gui.centerShell(dialog);		    
		    dialog.open();
		    
		  
	}
	
	private void setIsClosed(boolean b) {
		this.isClosed = b;
		
	}
	
	public boolean isClosed() {
		return isClosed;
	}
	
	protected void createControlsOpenAccess() {
		//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
		//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
		dialog = gui.createOsSpecificDialog();
		dialog.setSize(370, 130);
	    dialog.setText(Application.getInstance().messages.DialogOpenAccessName);
	  
	    dialog.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event event) {
				setIsClosed(true);
			}
		});
	    
	    dialog.addListener(SWT.Traverse, new Listener() {
	        public void handleEvent(Event event) {
	          switch (event.detail) {
	          case SWT.TRAVERSE_ESCAPE:
	            dialog.dispose();
	            event.detail = SWT.TRAVERSE_NONE;
	            event.doit = false;
	            break;
	          }
	        }
	      });
	    
	    GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		
		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
		gridData.horizontalSpan= 1;
	    gridData.minimumWidth = 50;
		
		dialog.setLayout(gridLayout);
	    
		final Label state = new Label(dialog, SWT.NONE);
	    state.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2,1));
		
	    final Label password = new Label(dialog, SWT.NONE);
	    
	    password.setText(Application.getInstance().messages.DialogOpenAccessEnterPwdLbl);
	    final Text  passwordText = new Text(dialog, SWT.BORDER);
	    passwordText.setTextLimit(gui.maxPswLenght);
	    passwordText.addListener(SWT.Verify, gui.getPswListener());
	    
	    passwordText.setLayoutData(gridData);
	    //settings.read();
	    
	    final Button okButton = new Button(dialog, SWT.PUSH);
	    //okButton.setFocus();
	    okButton.setText("&OK");
	    okButton.setLayoutData(gridData);
	    okButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Request request = new Request();
				request.setPasswordToWork(passwordText.getText());
				request.openAccess();
					Integer statusSccess = request.getStatusAccess();
					if (statusSccess!= null) {
						if (statusSccess == 0) {
							state.setText(Application.getInstance().messages.DialogOpenAccessPwdIncorrect);
							state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));	
							setAccessIsOpened(false);
						} 
						
						if (statusSccess == 1) {
							state.setText(Application.getInstance().messages.DialogOpenAccessIsOpened);
							state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_DARK_GREEN));
							setAccessIsOpened(true);
							dialog.dispose();
						}
						
					} else {
						setNoConnection(true);
						state.setText(Application.getInstance().messages.DialogOpenAccessNoConnection);
						state.setForeground(dialog.getDisplay().getSystemColor(SWT.COLOR_RED));
						dialog.dispose();
					}		
			}
	
		});
	  	 
	    passwordText.addKeyListener(new KeyAdapter() {	
	    	public void keyPressed(KeyEvent e) {
	    		if(e.keyCode == SWT.CR) {
	    			okButton.notifyListeners(SWT.Selection, new Event());
	    		}
	    	}
	    });
	    
	    dialog.pack();
	    gui.centerShell(dialog);		    
	    dialog.open();
	    
	   
	    
	    // swt 
	    while (!dialog.isDisposed ()) {
			if (!dialog.getDisplay().readAndDispatch ()) dialog.getDisplay().sleep (); 
		} 
	    dialog.dispose ();
	}

	private void setNoConnection(boolean b) {
		this.noConnection = b;
		
	}
	
	public boolean noConnection() {
		return noConnection;
	}
	
	public boolean accessIsOpened() {
		return accessIsOpened;
	}

	private void setAccessIsOpened(boolean accessIsOpened) {
		this.accessIsOpened = accessIsOpened;
	}
	
}
