package s.d.manager.dialogs;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;
import s.d.manager.model.Request;

public class DialogPassword {

	private Shell dialog;	
	private Gui gui = new Gui();
	public DialogPassword() {
		createControls();
	}
	
	public void createControls() {		
		//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
		//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
		dialog = gui.createOsSpecificDialog();
		dialog.setSize(370, 130);
	    dialog.setText(Application.getInstance().messages.DialogPasswordName);
	    dialog.setLayout(new GridLayout(2, false));
	    dialog.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event event) {
				dialog.dispose();
			}
		});
	    
	    dialog.addListener(SWT.Traverse, new Listener() {
	        public void handleEvent(Event event) {
	          switch (event.detail) {
	          case SWT.TRAVERSE_ESCAPE:
	            dialog.dispose();
	            event.detail = SWT.TRAVERSE_NONE;
	            event.doit = false;
	            break;
	          }
	        }
	      });
	    
	    Label currentPassword = new Label(dialog, SWT.NONE);
	    currentPassword.setText(Application.getInstance().messages.DialogPasswordCurrentPasswordLbl);
	    
	    final Text  currentPasswordText = new Text(dialog, SWT.BORDER);
	    currentPasswordText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
	    currentPasswordText.setTextLimit(gui.maxPswLenght);
	    currentPasswordText.addListener(SWT.Verify, gui.getPswListener());
	    
	    
	    Label newPassword = new Label(dialog, SWT.NONE);
	    newPassword.setText(Application.getInstance().messages.DialogPasswordNewPasswordLbl);
	    final Text newPasswordText = new Text(dialog, SWT.BORDER);
	    newPasswordText.setTextLimit(gui.maxPswLenght);
	    newPasswordText.addListener(SWT.Verify, gui.getPswListener());
	    
	    Label confirmPassword = new Label(dialog, SWT.NONE);
	    confirmPassword.setText(Application.getInstance().messages.DialogPasswordConfirmPasswordLbl);
	    final Text confirmPasswordText = new Text(dialog, SWT.BORDER);
	    confirmPasswordText.setTextLimit(gui.maxPswLenght);
	    confirmPasswordText.addListener(SWT.Verify, gui.getPswListener());
	    
	    final Button okButton = new Button(dialog, SWT.PUSH);
	    okButton.setText("&OK");
	    okButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
	    
	    okButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				String newPassword = confirmPasswordText.getText();
				String newPasswordConfirm = newPasswordText.getText();
				if (newPassword.equals(newPasswordConfirm)) {
					if (confirmPasswordText.getText() == "") {
						MessageDialog.openInformation(dialog, Application.getInstance().messages.DialogTitleWarning, Application.getInstance().messages.DialogPasswordCouldntBeEmpty);
						return;
					}
					if (newPasswordText.getCharCount() != 4) {
						MessageDialog.openInformation(dialog, Application.getInstance().messages.DialogTitleWarning, Application.getInstance().messages.DialogPasswordCannotBeLonger);
						return;
					}
					
					Integer statusAccess = null;
					
					Request request = new Request();
					request.setPasswordToWork(currentPasswordText.getText());
				    request.openAccess();
				    statusAccess = request.getStatusAccess();
					
				    if (statusAccess == null) {
				    	MessageDialog.openError(dialog, Application.getInstance().messages.DialogTitleWarning, Application.getInstance().messages.DialogCantConnect + Application.getInstance().messages.DialogPasswordCheckSnmpSettings);
				    	return;
				    }
				    
				    if (statusAccess == 1) {
				    	request.setNewPassword(newPassword);
				    	request.closeAccess();
				    	dialog.close();
				    	
				    	request.setPasswordToWork(newPassword);
				    	if (request.openAccess()) {
				    		request.closeAccess();
				    		MessageDialog.openInformation(dialog, Application.getInstance().messages.DialogTitleWarning, Application.getInstance().messages.DialogPasswordChangeSuccess);
				    		return;
				    	} else {
				    		MessageDialog.openError(dialog, Application.getInstance().messages.DialogTitleWarning, Application.getInstance().messages.DialogPasswordChangeFailed);
				    		return;
				    	}
				    }
				    if (statusAccess == 0) {
				    	MessageDialog.openError(dialog, Application.getInstance().messages.DialogTitleWarning, Application.getInstance().messages.DialogPasswordIncorrect);
				    	return;
				    }
				    
				} else {
					MessageDialog.openError(dialog,  Application.getInstance().messages.DialogTitleWarning, Application.getInstance().messages.DialogPasswordPswdAndConfirmDoesntMatch);
					return;
				}
			}
		});
	    
	    confirmPasswordText.addKeyListener(new KeyAdapter() {	
	    	public void keyPressed(KeyEvent e) {
	    		if(e.keyCode == SWT.CR) {
	    			okButton.notifyListeners(SWT.Selection, new Event());
	    		}
	    	}
	    });
	    
	    dialog.pack ();
	    gui.centerShell(dialog);
	    dialog.open();
	}
	
	
}
