package s.d.manager.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;

public class DialogSelectConnection {
	
	private Shell dialog;
	private  boolean writeToThisUps;
	private  boolean connectToNewUps;
	private Gui gui = new Gui();
	private boolean connectToLocalIp;
	private Button connectToLocalIpBtn;
	public DialogSelectConnection() {
		createControls();
	}
	
	public void open() {
		
	}
	
	private void createControls() {
		wtiteToThisUps(false);
		connectToNewUps(false);	
		//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
		//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
		dialog = gui.createOsSpecificDialog();
		dialog.setSize(370, 130);
		dialog.setText(Application.getInstance().messages.DialogConnection);
	    
		dialog.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event event) {
				dialog.dispose();
			}
		});
		
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		
	    dialog.setLayout(gridLayout);
	    Label text = new Label(dialog, SWT.NONE);
	    text.setText(Application.getInstance().messages.DialogSelectConnectionName);
	      
	    connectToLocalIpBtn = new Button(dialog, SWT.CHECK);
	    
	    connectToLocalIpBtn.setSelection(true);
	    setConnectToLocalIp(true);
	    connectToLocalIpBtn.setText(Application.getInstance().messages.ChkBoxConnectionFromLocalIp);
	    connectToLocalIpBtn.setToolTipText(" " + Application.getInstance().messages.ChkBoxConnectionFromLocalIpTooltip);
	    connectToLocalIpBtn.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2,1));
	    connectToLocalIpBtn.addSelectionListener(new SelectionAdapter() {
			@Override
		    public void widgetSelected(SelectionEvent e) {
		        Button button = (Button) e.widget;
		        if (button.getSelection())
		            setConnectToLocalIp(true);
		        else
		        	setConnectToLocalIp(false);
		    }
		});
	    
	    text.setLayoutData(getGridDataText());
	    Button writeToThisUpsBtn = new Button(dialog, SWT.PUSH);
	    
	    writeToThisUpsBtn.setText(Application.getInstance().messages.DialogSelectConnectionWriteToThisUPSBtn);
	   
	    Button connectToNewObjectBtn = new Button(dialog, SWT.PUSH);
	    connectToNewObjectBtn.setFocus();
	    connectToNewObjectBtn.setText(Application.getInstance().messages.DialogSelectConnectionConnectToNewUPSBtn);
	 
	   /* Button connectFromOutsideBtn = new Button(dialog, SWT.PUSH);
	    connectFromOutsideBtn.setText(" ");*/
	    
	    writeToThisUpsBtn.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				wtiteToThisUps(true);
				dialog.close();
			}	
		});
	    
	    connectToNewObjectBtn.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				connectToNewUps(true);	
				dialog.close();
			}	
		});
	    
	    /*connectFromOutsideBtn.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				setConnectFromOutside(true);	
				dialog.close();
			}	
		});*/
	    
	    dialog.pack ();
	    gui.centerShell(dialog);
	    dialog.open();
	    // swt 
	    while (!dialog.isDisposed ()) {
			if (!dialog.getDisplay().readAndDispatch ()) dialog.getDisplay().sleep (); 
		} 
	    dialog.dispose ();
	}
	
	public boolean writeToThisUps() {
		return writeToThisUps;
	}
	
	public  boolean connectToNewUps() {
		return connectToNewUps;
	}
	
	private void connectToNewUps(boolean b) {
		connectToNewUps = b;
	}
	
	private void wtiteToThisUps(boolean b) {
		writeToThisUps = b;
	}
	
	private GridData getGridDataText(){
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		gridData.horizontalSpan = 2;
		return gridData;
	}

	public boolean isConnectToLocalIp() {
		return connectToLocalIp;
	}

	private void setConnectToLocalIp(boolean connectToLocalIp) {
		this.connectToLocalIp = connectToLocalIp;
	}
	
}

