package s.d.manager.dialogs;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;

public class DialogServiceParams {

	private Shell dialog;
	private String values;
	private Gui gui = new Gui();
	public DialogServiceParams(String values) {
		this.values = values;
		createControls();
	}
	
	public void createControls() {
		//dialog = new Shell(Application.display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL );
		//dialog = new Shell(Application.getInstance().display,SWT.SHELL_TRIM| SWT.TOOL | SWT.ON_TOP | SWT.CLOSE|SWT.APPLICATION_MODAL);
		//dialog = new Shell(Application.getInstance().display, SWT.DIALOG_TRIM|SWT.APPLICATION_MODAL);//Linux kde,gnome
		dialog = gui.createOsSpecificDialog();
		dialog.setSize(370, 130);
	    dialog.setText(Application.getInstance().messages.DialogServiceParams);
	  
	    dialog.addListener(SWT.Close, new Listener() {
			public void handleEvent(Event event) {
				dialog.dispose();
			}
		});
	    
	    dialog.addListener(SWT.Traverse, new Listener() {
	        public void handleEvent(Event event) {
	          switch (event.detail) {
	          case SWT.TRAVERSE_ESCAPE:
	            dialog.dispose();
	            event.detail = SWT.TRAVERSE_NONE;
	            event.doit = false;
	            break;
	          }
	        }
	      });
	    
	    GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		
		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
		gridData.horizontalSpan= 1;
	    gridData.minimumWidth = 50;
		
		dialog.setLayout(gridLayout);
	    
		final Label state = new Label(dialog, SWT.NONE);
	    if (values != null) {
	    	state.setText(values);
	    } else {
	    	state.setText("");
	    }
	
	    dialog.pack ();
	    gui.centerShell(dialog);
	    dialog.open();
	    // swt 
	    while (!dialog.isDisposed ()) {
			if (!dialog.getDisplay().readAndDispatch ()) dialog.getDisplay().sleep (); 
		} 
	    dialog.dispose ();
	}
}
