package s.d.manager.dialogs;

import java.awt.Toolkit;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import s.d.manager.model.Application;
import s.d.manager.model.Gui;
import s.d.manager.model.Pc;
import s.d.manager.model.Settings;

public class DialogShutDown {
	private Job job;
	private Label label;
	private int i;
	private String dialogText;
	private int shutDownCase;
	private Boolean timerJobStop;
	public Shell dialog;
	private Gui gui = new Gui();
	private int dialogType; //  / 
	private int offset;
	public Boolean isVisible;
	final Settings settings = new Settings();
	public DialogShutDown(String dialogText, int shutDown, int dialogType, int offset) {
		this.dialogText = dialogText;
		this.shutDownCase = shutDown;
		this.offset = offset;
		timerJobStop = false;
		this.dialogType = dialogType;
		
		createAsyncDialog();
		//createControls();
		//timerJobRun();
	}
	
	
	public void close() {
		if (dialog != null) {
		//if (dialog == null) {
			Display.getDefault().asyncExec(new Runnable() {			
				public void run() {	
					if (!dialog.isDisposed()) {
						isVisible = false;
						dialog.close();
						dialog.dispose();
					}
				}
			});
		}
	}
	
	private void createAsyncDialog() { //   
		if (dialog == null) {
			//Application.dialogIsShown = true;
			Display.getDefault().asyncExec(new Runnable() {
			//display.asyncExec(new Runnable() {
				public void run() {	
					createControls();
					timerJobRun();
					//RequestJobS.getInstance().batteryLowAgain = false;
				}		
			});
		}
	}
	
	private void createControls(){
		isVisible = true;
		
		//dialog = new Shell(Application.getInstance().display, SWT.SHELL_TRIM | SWT.TOOL | SWT.ON_TOP |SWT.APPLICATION_MODAL);
		dialog = gui.createOsSpecificDialog();
		dialog.setSize(370, 130);
	    dialog.setText(Application.getInstance().messages.DialogTitleWarning);
	    
	    FormData labelData = new FormData();
	    labelData.top = new FormAttachment(1, 8);
	    
	    label = new Label(dialog, SWT.NONE);
	    label.setLayoutData(labelData);
	    Button okButton = new Button(dialog, SWT.PUSH);
	    okButton.setText("&OK");
	    
	    Button cancelButton = new Button(dialog, SWT.PUSH);
	    cancelButton.setText("&Cancel");
	    cancelButton.pack();
	    
	    FormLayout form = new FormLayout();
	    form.marginWidth = form.marginHeight = 8;
	    dialog.setLayout(form);
	    
	    FormData okData = new FormData();
	    okData.top = new FormAttachment(60, 8);
	    okData.width = 70;
	    okData.right = new FormAttachment(75, 8);
	    okButton.setLayoutData(okData);
	    
	    FormData cancelData = new FormData();
	    cancelData.left = new FormAttachment(okButton, 8);
	    cancelData.width = 70;
	    cancelData.top = new FormAttachment(okButton, 0, SWT.TOP);
	    cancelButton.setLayoutData(cancelData);
	    cancelButton.setFocus();
	    cancelButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				//RequestJobS.getInstance().batteryLowAgain = false;//   ,   .
				timerJobStop();
				//Application.dialogIsShown = false;
				//Application.innputLineFailDialog = null;
				//Application.batteryLowDialog = null;
				dialog.close();
				dialog.dispose();
				isVisible = false;
			}
	    });
	    
	    okButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				timerJobStop();
				shutDown(shutDownCase);
				//Application.innputLineFailDialog = null;
				//Application.batteryLowDialog = null;
				//Application.showAlarmDialogs = false;
				dialog.close();
				dialog.dispose();
				isVisible = false;
			}
	    });	
	    
	    dialog.addListener (SWT.Close, new Listener () {
			public void handleEvent (Event event) {
				timerJobStop();
				//Application.dialogIsShown = false;
				dialog.dispose();
				/*Application.innputLineFailDialog = null;
				Application.batteryLowDialog = null;*/
				isVisible = false;
				//Application.showAlarmDialogs = true;
			}
		});
	    
	    dialog.pack ();
	    gui.centerShell(dialog, offset);
	    dialog.open();
	    
	}
	
	private void timerJobRun() { //  ,    
		job = new Job("First1 Job") {
			 @Override
		     	protected IStatus run(IProgressMonitor monitor) {
				 	runTimer();
				 	if (monitor.isCanceled()) return Status.CANCEL_STATUS;
				 	return Status.OK_STATUS;
		      }

		 };
		 job.setUser(true);
		 job.schedule();
	}
	
	private void timerJobStop() {//  ,    
		try {
			if (job.getState() != 0) {
				timerJobStop = true;
				job.cancel();
				if (!job.cancel()) {
					try {
						job.join();
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
			//started = false;
			}
		} catch (Exception e) {
			
		}
	}
	
	private void syncWithUi() {//    
		Display.getDefault().asyncExec(new Runnable() {
	          public void run() {
	        	  if (!dialog.isDisposed()) {
		        	  switch (dialogType) {
		        	  case 0: setLabelValue(getLabel(),dialogText+" "+String.valueOf(i)+" c.");
					  		  dialog.pack ();
					  		  break;
		        	  case 1: setLabelValue(getLabel(),dialogText+" ");
					  		  dialog.pack ();
					  		  break;
		        	  }
	        	  }
	          }
		});
	}
	
	private void runTimer() { //   
		int period = 30;
		try {
			settings.read();
			period = Integer.parseInt(settings.shutDownPeriod);
			if (period<=0)
				period = 30;
		} catch (Exception e) {
			period = 30;
		}
		/*for (i=period; i>0; i--) {
			if (timerJobStop == false) {
				syncWithUi();
				if (settings.soundSignalization.equals("1"))
					Toolkit.getDefaultToolkit().beep();
				try {Thread.sleep(1000);} catch (Throwable e) {}
			}
		}*/
		
		switch (dialogType) {
  	  		case 0: 
  	  				for (i=period; i>0; i--) {
  	  					if (timerJobStop == false) {
  	  						syncWithUi();
  	  						beep();
  	  					}
  	  				};
  	  			 break;
  	  		case 1: 
  	  				do {
  	  					syncWithUi();
  	  					beep();
  	  				} while(timerJobStop == false);
		  			break;
		}
		
		if (timerJobStop != true) {
			shutDown(shutDownCase);
		}
		
	}
	
	private void beep() {
		settings.read();
		if (settings.soundSignalization.equals("1"))
				Toolkit.getDefaultToolkit().beep();
			try {Thread.sleep(1000);} catch (Throwable e) {}
	}
	
	private void shutDown(int value) {
		switch (value) {
		   case 0: 	//System.out.println("...");
			   		Pc.shutdown();
		   			break;
		   case 1: 	//System.out.println("...");
			   		Pc.sleep();
		   			break;
		   case 2: 	//System.out.println("  ...");
			   		break;
		   }
	}
	
	public void setLabelValue(Label label, String value) {
		try {
			label.setText(value);
			label.pack();
		} catch (Exception e) {
			
		}
 	}
	
	public Label getLabel() {
		return label;
	}

}
