package s.d.manager.model;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Formatter;
import java.util.logging.LogRecord;

import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import s.d.manager.dialogs.DialogShutDown;
import s.d.manager.views.Messages;

public class Application {

	public DialogShutDown inputLineFailDialog;	
	public DialogShutDown batteryLowDialog;
	
	public Composite parent;
	public Shell shell;
	public Display display;
	public CustomTray tray;
	public IEventBroker broker;
	public IEclipseContext context;
	public Boolean showAlarmDialogs = true;
	public int i = 0;
	public Messages messages;
	//public Logger logger = Logger.getLogger("LOG");
	public boolean isBeeperON = false;
	
	private static class ApplicationSLoader {
        static Application ApplicationS = new Application();
    }
	
	public static Application getInstance() {
    	
        return ApplicationSLoader.ApplicationS;
    }
	
	public Application() {
	
	}
	
	public void init(Shell shell, Display display, CustomTray tray, IEventBroker broker, IEclipseContext context, Messages messages) {
		this.shell = shell;
		this.display = display;
		this.tray = tray;
		this.broker = broker;
		this.context = context;
		this.messages = messages;
		/*FileHandler fh = null;
		try {
			fh = new FileHandler("requestingLog.log");
			CustomRecordFormatter formatter = new CustomRecordFormatter();
			fh.setFormatter(formatter);
	        logger.addHandler(fh);
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} */
		
	}
	
	public Shell getShell() {
		return shell;
	}
	
	class CustomRecordFormatter extends Formatter {
	    @Override
	    public String format(LogRecord r) {
	    	SimpleDateFormat sdf = new SimpleDateFormat("MMM dd,yyyy HH:mm");    
	    	Date resultDate = new Date(System.currentTimeMillis());
	    	StringBuilder sb = new StringBuilder();	   

	    	sb.append(sdf.format(resultDate)).append(" - ");
	    	sb.append(formatMessage(r));	
	    	sb.append(System.getProperty("line.separator"));
	        
	        return sb.toString() ;
	    }

	}
}
