package s.d.manager.model;
import java.net.MalformedURLException;
import java.net.URL;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tray;
import org.eclipse.swt.widgets.TrayItem;

public class CustomTray {
	private static TrayItem item;
	private static Tray tray;
	private Display display;	
	public CustomTray(final Composite parent, final Display display){
		final Shell shell = parent.getShell();
		this.display = display;
		tray = display.getSystemTray ();
		if (tray == null) {
			System.out.println ("The system tray is not available");
		} else {
			item = new TrayItem (tray, SWT.NONE);
			item.setToolTipText("SWT TrayItem");
			setImage(1);
			item.addSelectionListener(new SelectionAdapter() {
				@Override
				public void widgetSelected(SelectionEvent e) {
					if (shell.isVisible()) {
						shell.setVisible(false);
					}else{
						//shell.setVisible(true);
						shell.open(); 
						shell.setMinimized(false); 
						shell.forceActive(); 
						shell.forceFocus(); 
					}
				}
			});
		}
	
	}
	
	public void setImage(final int i){
		
		Display.getDefault().asyncExec(new Runnable() {
			public void run(){
				if (!item.isDisposed()){
					if (item.getImage() != null) {
						item.getImage().dispose();
					}
					item.setImage(getImage(i));
					switch (i){
						case 1: item.setToolTipText(Application.getInstance().messages.UpsTrayConnected);
								break;
						case 2: item.setToolTipText(Application.getInstance().messages.UpsTrayBatteryLow);
								break;
						case 3: item.setToolTipText(Application.getInstance().messages.UpsTrayConnectionLost);
								break;
						case 4: item.setToolTipText(Application.getInstance().messages.SchemeModeBypass);
							break;
					}
				}
			}
		});
	}
	
	public void setTooltipText(final String s){
		Display.getDefault().asyncExec(new Runnable() {
			public void run(){
				if (!item.isDisposed()){
					item.setToolTipText(s);
				}
			}
		});
	}
	
	public void deleteItem(){
		display.asyncExec(new Runnable() {
			public void run(){
				if (!item.isDisposed()){
					item.dispose();
				}
			}
		});
	}
	
	private Image getImage(int i){
		ImageDescriptor icon = null;
		try {
			switch (i){
			case 1: //icon = ImageDescriptor.createFromURL(new URL("platform:/plugin/s.d.manager/icons/shtyl_ok.gif"));
					icon = ImageDescriptor.createFromURL(new URL("platform:/plugin/s.d.manager/icons/shtyl_ok.png"));
					break;
			case 2: icon = ImageDescriptor.createFromURL(new URL("platform:/plugin/s.d.manager/icons/shtyl_problem.png"));
					break;
			case 3: icon = ImageDescriptor.createFromURL(new URL("platform:/plugin/s.d.manager/icons/shtyl_no_connection.png"));
					break;			
			case 4: icon = ImageDescriptor.createFromURL(new URL("platform:/plugin/s.d.manager/icons/shtyl_no_connection.png"));
					break;
			}
			/*switch (i){
			case 1: icon = Activator.
					ImageDescriptor.c("platform:/plugin/s.d.manager/icons/shtyl_ok.gif");
					break;
			case 2: icon = ImageDescriptor.createFromURL(new URL("platform:/plugin/s.d.manager/icons/shtyl_problem.gif"));
					break;
			case 3: icon = ImageDescriptor.createFromURL(new URL("platform:/plugin/s.d.manager/icons/shtyl_no_connection.gif"));
					break;
			}*/
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return icon.createImage();
	}
	
}
