package s.d.manager.model;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import org.eclipse.core.runtime.Platform;
import org.eclipse.swt.widgets.Combo;

import s.d.manager.model.ups.NetworkSettings;
import s.d.manager.model.ups.Ups;
public class Settings {

	public String port = "";
	public String mask = "";
	public String gateway = "";
	public String communityRead = "";
	public String communityWrite = "";
	//public String password = "";
	public String onBatteryLowEvent = "";
	public String onInputLineFailEvent = "";
	public String soundSignalization = "";
	
	public String upsRatedACVoltage = "";
	public String upsMaxACCurrent = "";
	public String upsNominalBatVoltage = "";
	public String upsRatedFrequency = "";
	public String upsPhaseCount = "";
	
	private Properties prop;
	
	public String ipAddressUPS = "";
	public String ipAddressUPSWan = "";
	//public List<String> ipAddressTrapRecievers = new ArrayList<String>();
	public String ipAddressTrap1 = "";
	public String ipAddressTrap2 = "";
	public String ipAddressTrap3 = "";
	public String ipAddressTrap4 = "";
	public String trapLanguage = "";
	public String systemLanguage= "";	
	public String shutDownPeriod="";
	
	public final String defaultIpAddress = "192.168.0.1";
	public final String defaultIpAddressWan = "192.168.0.1";
	public final String defaultPort = "161";
	public final String defaultMask = "255.255.255.0";
	public final String defaultGateway = "192.168.0.100";
	public final String defaultPassword = "1111";
	public final String defaultCommunityRead = "public";
	public final String defaultCommunityWrite = "public";
	public final String defaultPhaseCount = "1";
	public final String defaultTrapLanguage = "0";
	public final String defaultSystemLanguage = "1";
	public final String defaultShutDownPeriod = "30";
	public final String defaultSoundSignalization = "0";
	
	private static File file;
public Settings() {	
		prop = new Properties();
		file = new File(Platform.getInstanceLocation().getURL().getPath()+"config.properties");
		if(!file.exists()){
			  try {
				file.createNewFile();
				writeDefault();
			} catch (IOException e2) {
				// TODO Auto-generated catch block
				e2.printStackTrace();
			}
		};
		
}

	public void write() {
	try {
		prop.setProperty("ipAddressUPS",ipAddressUPS);
		prop.setProperty("ipAddressUPSWan",ipAddressUPSWan);
		prop.setProperty("port", port);
		prop.setProperty("mask", mask);
		prop.setProperty("gateway", gateway);
		//prop.setProperty("password", password);
		prop.setProperty("communityRead", communityRead);
		prop.setProperty("communityWrite", communityWrite);
		prop.setProperty("onBatteryLowEvent", onBatteryLowEvent);
		prop.setProperty("onInputLineFailEvent", onInputLineFailEvent);
		prop.setProperty("soundSignalization", soundSignalization);
		/*try {
			prop.setProperty("shutDownPeriod", shutDownPeriod);
		} catch (Exception e) {
			prop.setProperty("shutDownPeriod", defaultShutDownPeriod);
		}*/
		
		try {
			prop.setProperty("upsRatedACVoltage", upsRatedACVoltage);
			prop.setProperty("upsMaxACCurrent", upsMaxACCurrent); 
			prop.setProperty("upsNominalBatVoltage", upsNominalBatVoltage);
			prop.setProperty("upsRatedFrequency", upsRatedFrequency);
			prop.setProperty("upsPhaseCount", upsPhaseCount);
		} catch (Exception e) {
			writeDefaultPassportParams();
		}
		/*for (int i = 0; i <ipAddressTrapRecievers.size(); i++) {
			prop.setProperty("ipAddressTrap" + i, ipAddressTrapRecievers.get(i));
		}*/
		try {
			prop.setProperty("ipAddressTrap1", ipAddressTrap1);
			prop.setProperty("ipAddressTrap2", ipAddressTrap2);
			prop.setProperty("ipAddressTrap3", ipAddressTrap3);
			prop.setProperty("ipAddressTrap4", ipAddressTrap4);
			prop.setProperty("trapLanguage", trapLanguage);
		} catch (Exception e) {
			writeDefaultTrapAddr();
		}
		
		try {
			prop.setProperty("systemLanguage", systemLanguage);
		} catch (Exception e) {
			
		}
		
		prop.store(new FileOutputStream(file), null);
	} catch (IOException ex) {
		//ex.printStackTrace();
    }
}

	public void writeWorkingNetworkSettings(NetworkSettings networkSettings) {
		try {
			prop.setProperty("ipAddressUPS", networkSettings.getIpAddress());
			prop.setProperty("ipAddressUPSWan", networkSettings.getIpAddressWan());
			prop.setProperty("port", networkSettings.getPort());
			prop.setProperty("mask", networkSettings.getMask());
			prop.setProperty("gateway", networkSettings.getGateway());
			prop.setProperty("communityRead", networkSettings.getCommunityRead());
			prop.setProperty("communityWrite", networkSettings.getCommunityWrite());
			prop.store(new FileOutputStream(file), null);
		} catch (IOException ex) {

		}
	}

	public void refresh(){
		write();
		read();
	}

	public void writeDefault(){
		try {
			prop.setProperty("ipAddressUPS", defaultIpAddress);
			prop.setProperty("ipAddressUPSWan", defaultIpAddressWan);
			prop.setProperty("port", defaultPort);
			prop.setProperty("mask", defaultMask);
			prop.setProperty("gateway", defaultGateway);
			prop.setProperty("password", defaultPassword);
			prop.setProperty("communityRead", defaultCommunityRead);
			prop.setProperty("communityWrite", defaultCommunityWrite);
			prop.setProperty("onBatteryLowEvent", "2");
			prop.setProperty("onInputLineFailEvent", "2");
			prop.setProperty("upsPhaseCount", defaultPhaseCount);
			String upsPassportDefault = "n/a";
			prop.setProperty("upsRatedACVoltage", upsPassportDefault);
			prop.setProperty("upsMaxACCurrent", upsPassportDefault); 
			prop.setProperty("upsNominalBatVoltage", upsPassportDefault);
			prop.setProperty("upsRatedFrequency", upsPassportDefault);
			prop.setProperty("upsPhaseCount", defaultPhaseCount);
			
			prop.setProperty("ipAddressTrap1", upsPassportDefault);
			prop.setProperty("ipAddressTrap2", upsPassportDefault);
			prop.setProperty("ipAddressTrap3", upsPassportDefault);
			prop.setProperty("ipAddressTrap4", upsPassportDefault);
			prop.setProperty("trapLanguage", defaultTrapLanguage);
			prop.setProperty("systemLanguage", defaultSystemLanguage);
			prop.setProperty("shutDownPeriod", defaultShutDownPeriod);
			prop.setProperty("soundSignalization", defaultSoundSignalization);
			
			prop.store(new FileOutputStream(file), null);
		} catch (IOException ex) {
			//ex.printStackTrace();
	    }
	}

	public  void writeDefaultTrapAddr () {
		try {
			
			String upsPassportDefault = "n/a";
			prop.setProperty("ipAddressTrap1", upsPassportDefault);
			prop.setProperty("ipAddressTrap2", upsPassportDefault);
			prop.setProperty("ipAddressTrap3", upsPassportDefault);
			prop.setProperty("ipAddressTrap4", upsPassportDefault);
			prop.setProperty("trapLanguage", defaultTrapLanguage);
			prop.store(new FileOutputStream(file), null);
		} catch (IOException ex) {
			//ex.printStackTrace();
	    }
	}

	public void writeDefaultPassportParams() {
		try {
			String upsPassportDefault = "n/a";
			prop.setProperty("upsRatedACVoltage", upsPassportDefault);
			prop.setProperty("upsMaxACCurrent", upsPassportDefault); 
			prop.setProperty("upsNominalBatVoltage", upsPassportDefault);
			prop.setProperty("upsRatedFrequency", upsPassportDefault);
			prop.setProperty("upsPhaseCount", defaultPhaseCount);
			prop.store(new FileOutputStream(file), null);
		} catch (IOException ex) {
			//ex.printStackTrace();
	    }
	}

	public void read() {
		try {
			prop.load(new FileInputStream(file));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		ipAddressUPS = prop.getProperty("ipAddressUPS");
		ipAddressUPSWan = prop.getProperty("ipAddressUPSWan");
		port = prop.getProperty("port");
		mask = prop.getProperty("mask");
		gateway = prop.getProperty("gateway");
		//password = prop.getProperty("password");
		communityRead = prop.getProperty("communityRead");
		communityWrite = prop.getProperty("communityWrite");
		onBatteryLowEvent = prop.getProperty("onBatteryLowEvent");
		onInputLineFailEvent = prop.getProperty("onInputLineFailEvent");
		upsRatedACVoltage = prop.getProperty("upsRatedACVoltage");
		upsMaxACCurrent = prop.getProperty("upsMaxACCurrent");
		upsNominalBatVoltage = prop.getProperty("upsNominalBatVoltage");
		upsRatedFrequency = prop.getProperty("upsRatedFrequency");
		upsPhaseCount = prop.getProperty("upsPhaseCount");
		ipAddressTrap1 = prop.getProperty("ipAddressTrap1");
		ipAddressTrap2 = prop.getProperty("ipAddressTrap2");
		ipAddressTrap3 = prop.getProperty("ipAddressTrap3");
		ipAddressTrap4 = prop.getProperty("ipAddressTrap4");
		trapLanguage = prop.getProperty("trapLanguage");
		systemLanguage = prop.getProperty("systemLanguage");
		shutDownPeriod = prop.getProperty("shutDownPeriod");
		soundSignalization = prop.getProperty("soundSignalization");
	}

	public void writeSystemLanguageValue(Combo systemLanguageCombo) {
		systemLanguage = Integer.toString(systemLanguageCombo.getSelectionIndex());		
		prop.setProperty("systemLanguage", systemLanguage);
		try {
			prop.store(new FileOutputStream(file), null);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void writeActionComboValues(Combo alarmEventBatteryLow, Combo alarmEventInputLineFail) {
		onBatteryLowEvent = Integer.toString(alarmEventBatteryLow.getSelectionIndex());
		onInputLineFailEvent = Integer.toString(alarmEventInputLineFail.getSelectionIndex());
		prop.setProperty("onBatteryLowEvent", onBatteryLowEvent);
		prop.setProperty("onInputLineFailEvent", onInputLineFailEvent);
		try {
			prop.store(new FileOutputStream(file), null);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void writeSoundSignalizationCombo(Combo soundSignalizationCombo) {
		try {
			soundSignalization = Integer.toString(soundSignalizationCombo.getSelectionIndex());
		} catch (Exception e) {
			soundSignalization = defaultSoundSignalization;
		}
		prop.setProperty("soundSignalization", soundSignalization);
		try {
			prop.store(new FileOutputStream(file), null);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void loadValuesFromUps(Ups ups) {

		ipAddressUPS = ups.getNetworkSettings().getIpAddress();
		ipAddressUPSWan = ups.getNetworkSettings().getIpAddressWan();
		mask =  ups.getNetworkSettings().getMask();
		gateway = ups.getNetworkSettings().getGateway();
		port = ups.getNetworkSettings().getPort();
		communityRead = ups.getNetworkSettings().getCommunityRead();
		communityWrite = ups.getNetworkSettings().getCommunityWrite();
		
		//TODO
		/*onBatteryLowEvent = Integer.toString(1);
		onInputLineFailEvent = Integer.toString(1);*/
		
		try {
			upsRatedACVoltage = ups.getPassportParams().getUpsRatedACVoltage();
		} catch (Exception e) {
			upsRatedACVoltage = "n/a";
		}
		try {
			upsMaxACCurrent = ups.getPassportParams().getUpsMaxACCurrent();
		} catch (Exception e) {
			upsMaxACCurrent = "n/a";
		}
		try {
			upsNominalBatVoltage = ups.getPassportParams().getUpsNominalBatVoltage();
		} catch (Exception e) {
			upsNominalBatVoltage = "n/a";
		}
		try {
			upsRatedFrequency = ups.getPassportParams().getUpsRatedFrequency();
		} catch (Exception e) {
			upsRatedFrequency = "n/a";
		}
		try {
			upsPhaseCount = Integer.toString(ups.getUpsPhaseNumber());
		} catch (Exception e) {
			upsPhaseCount = "n/a";
		}
		
		try {
			ipAddressTrap1 = ups.getSnmpTrapSettings().getTrapRecievers().get(0);
		} catch (Exception e) {
			ipAddressTrap1 = "n/a";
		}
		try {
			ipAddressTrap2 = ups.getSnmpTrapSettings().getTrapRecievers().get(1);
		} catch (Exception e) {
			ipAddressTrap2 = "n/a";
		}
		try {
			ipAddressTrap3 = ups.getSnmpTrapSettings().getTrapRecievers().get(2);
		} catch (Exception e) {
			ipAddressTrap3 = "n/a";
		}
		try {
			ipAddressTrap4 = ups.getSnmpTrapSettings().getTrapRecievers().get(3);
		} catch (Exception e) {
			ipAddressTrap4 = "n/a";
		}
		
		try {
			trapLanguage = Integer.toString(ups.getSnmpTrapSettings().getLanguageAsInt());
		} catch (Exception e) {
			trapLanguage = defaultTrapLanguage;
		}
		write();
		read();
	}
}


