package s.d.manager.model.ups;

import java.util.ArrayList;
import java.util.List;

import s.d.manager.model.Application;

public class Relay {

	private Integer assigment;
	private Integer polarity;
	private boolean extractIsFailed;
	
	public Relay() {
		
	}
	
	public Relay(Integer assigment, Integer polarity) {
		
		setAssigment(assigment);
		setPolarity(polarity);
	}

	public Integer getAssigment() {
		return assigment;
	}
	
	public String getAssigmentAsString() {
		try {
			//.    1
			return getRelayAssigmentConstants().get(getAssigment()-1);
		} catch (Exception e) {
			return "err";
		}
	}

	public List<String> getRelayAssigmentConstants() {
		List<String> result = new ArrayList<String>();

		result.add(Application.getInstance().messages.RelayCcAlarm);
		result.add(Application.getInstance().messages.RelayCcNoInputVoltage);
		result.add(Application.getInstance().messages.RelayCcLowBatteryDischarge);
		result.add(Application.getInstance().messages.RelayCcBatteryProblem);
		result.add(Application.getInstance().messages.RelayCcOnBypassSwitching);
		result.add(Application.getInstance().messages.RelayCcOverload);
		result.add(Application.getInstance().messages.RelayCcNormalMode);
		result.add(Application.getInstance().messages.ePo);
		result.add(Application.getInstance().messages.batteryDischarge);
		return result;
	}
	
	public List<String> getRelayPolarityConstants() {
		List<String> result = new ArrayList<String>();
		/*result.add(Application.getInstance().messages.RelayCcPolarityClose);
		result.add(Application.getInstance().messages.RelayCcPolarityOpen);*/
		
		result.add(Application.getInstance().messages.RelayCcPolarityOpen);
		result.add(Application.getInstance().messages.RelayCcPolarityClose);
		return result;
	}
	
	public void setAssigment(Integer assigment) {
		this.assigment = assigment;
	}

	public Integer getPolarity() {
		return polarity;
	}
	
	public String getPolarityAsString() {
		try {
			return getRelayPolarityConstants().get(getPolarity());
		} catch (Exception e) {
			return "err";
		}
	}

	public void setPolarity(Integer polarity) {
		this.polarity = polarity;
	}

	@Override
	public String toString() {
		return "Relay [getAssigment()=" + getAssigmentAsString() + ", getPolarity()="
				+ getPolarityAsString() + "]";
	}

	public boolean isExtractIsFailed() {
		return extractIsFailed;
	}

	public void setExtractIsFailed(boolean extractIsFailed) {
		this.extractIsFailed = extractIsFailed;
	}
	
}
