package s.d.manager.model.ups;

import java.util.ArrayList;
import java.util.List;

import s.d.manager.model.Settings;

public class Ups {

	private NetworkSettings networkSettings;
	private SnmpTrapSettings snmpTrapSettings;
	private UpsPassportParams passportParams;
	private ServiceParams serviceParams;
	private UpsParam upsParams;
	private ClimatControl climatControl;
	private Battery battery;
	private List<PhaseParam> phaseParams = new ArrayList<PhaseParam>();
	private List<Relay> relays = new ArrayList<Relay>();
	private List<ControlContact> controlContacts = new ArrayList<ControlContact>();
	private Integer upsPhaseNumber;
	
	private Settings settings = new Settings();
	
	public Ups() {
		
	}

	public void loadNetworkSettingsFromDisk() {
		settings.read();
		NetworkSettings networkSettings = new NetworkSettings();
		networkSettings.setIpAddress(settings.ipAddressUPS);		
		networkSettings.setIpAddressWan(settings.ipAddressUPSWan);
		networkSettings.setMask(settings.mask);
		networkSettings.setPort(settings.port);
		networkSettings.setGateway(settings.gateway);
		networkSettings.setCommunityRead(settings.communityRead);
		networkSettings.setCommunityWrite(settings.communityWrite);
		setNetworkSettings(networkSettings);
	}
	
	public NetworkSettings getNetworkSettings() {
		return networkSettings;
	}

	public void setNetworkSettings(NetworkSettings networkSettings) {
		this.networkSettings = networkSettings;
	}

	public UpsParam getUpsParams() {
		return upsParams;
	}

	public void setUpsParams(UpsParam upsParams) {
		this.upsParams = upsParams;
	}

	public List<PhaseParam> getPhaseParams() {
		return phaseParams;
	}

	public void setPhaseParams(List<PhaseParam> phaseParams) {
		this.phaseParams = phaseParams;
	}

	public List<Relay> getRelays() {
		return relays;
	}

	public void setRelays(List<Relay> relays) {
		this.relays = relays;
	}

	public SnmpTrapSettings getSnmpTrapSettings() {
		return snmpTrapSettings;
	}

	public void setSnmpTrapSettings(SnmpTrapSettings snmpTrapSettings) {
		this.snmpTrapSettings = snmpTrapSettings;
	}

	public UpsPassportParams getPassportParams() {
		return passportParams;
	}

	public void setPassportParams(UpsPassportParams passportParams) {
		this.passportParams = passportParams;
	}

	public Integer getUpsPhaseNumber() {
		return upsPhaseNumber;
	}

	public void setUpsPhaseNumber(Integer upsPhaseNumber) {
		this.upsPhaseNumber = upsPhaseNumber;
	}

	public List<ControlContact> getControlContacts() {
		return controlContacts;
	}

	public void setControlContacts(List<ControlContact> controlContacts) {
		this.controlContacts = controlContacts;
	}

	public ServiceParams getServiceParams() {
		
		return serviceParams;
	}
	
	public String getServiceParamsAsString() {
		
		return serviceParams.toString();
	}

	public void setServiceParams(ServiceParams serviceParams) {
		this.serviceParams = serviceParams;
	}

	public ClimatControl getClimatControl() {
		return climatControl;
	}

	public void setClimatControl(ClimatControl climatControl) {
		this.climatControl = climatControl;
	}
	
	public Battery getBattery() {
		return battery;
	}

	public void setBattery(Battery battery) {
		this.battery = battery;
	}
}
