package s.d.manager.scheme;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.widgets.Display;

import s.d.manager.model.Colors;

public class Element {
	
	private GC gc;
	private Display display;
	//protected boolean toDraw = true;
	public Element(GC gc){
		//this.gc = gc;
		setGC(gc);
		getGC().setLineWidth(2);
		setDisplay(Display.getDefault());
		//getGC().setForeground(getDisplay().getSystemColor(SWT.COLOR_BLACK));
		//getGC().setForeground(Colors.CYAN);
		
	}
	
	public void dispose(){
		getGC().dispose();
	}
	
	private void setDisplay(Display display){
		this.display = display;
	}
	
	private Display getDisplay(){
		return display;
	}
	
	private void setGC(GC gc){
		this.gc = gc;
	}
	
	private GC getGC(){
		return gc;
	}
	
	public void setColor(Color color){
		//if (toDraw()){
			getGC().setForeground(color);///
		//}
	}
	
	/*public boolean toDraw(){
		return toDraw;
	}
	
	public void setToDraw(boolean toDraw){
		this.toDraw = toDraw;
	}*/
	
	public class Line extends Element{
		private int x1 = 0;
		private int y1 = 0;
		private int x2 = 0;
		private int y2 = 0;
		private int lineWidth = 70;
		private boolean toDraw = true;
		public Line(int x1,int y1){
			super(getGC());
			setX1(x1);
			setY1(y1);
			setX2(x1+lineWidth);
			setY2(y1);
			setToDraw(true);
			getGC().setForeground(Colors.GRAY);
			Draw();
		}
		
		public Line(int x1,int y1, boolean toDraw){
			super(getGC());
			setX1(x1);
			setY1(y1);
			setX2(x1+lineWidth);
			setY2(y1);
			getGC().setForeground(Colors.GRAY);
			setToDraw(toDraw);
			if (toDraw()){
				Draw();
			}
		}
		
		
		public Line(int x1,int y1, int x2, int y2){
			super(getGC());
			setX1(x1);
			setY1(y1);
			setX2(x2);
			setY2(y2);
			setToDraw(true);
			getGC().setForeground(Colors.GRAY);
			Draw();
	
		}
		
		public Line(int x1,int y1, int x2, int y2, boolean toDraw){
			super(getGC());
			setX1(x1);
			setY1(y1);
			setX2(x2);
			setY2(y2);
			getGC().setForeground(Colors.GRAY);
			setToDraw(toDraw);
			if (toDraw()){
				Draw();
			}
		}
		
		public void Draw(){
			getGC().drawLine(x1, y1, x2, y2);
		}
		
		public boolean toDraw(){
			return toDraw;
		}
		
		public void setToDraw(boolean toDraw){
			this.toDraw = toDraw;
		}
		
		public void setX1(int x1){
			this.x1 = x1;
		}
		
		public int getX1(){
			return x1;
		}
		
		public void setX2(int x2){
			this.x2 = x2;
		}
		
		public int getX2(){
			return x2;
		}
		
		public void setY1(int y1){
			this.y1 = y1;
		}
		
		public int getY1(){
			return y1;
		}
		
		public void setY2(int y2){
			this.y2 = y2;
		}
		
		public int getY2(){
			return y2;
		}
		
		public void setColor(Color color){
			if (toDraw()){
				getGC().setForeground(color);
				Draw();
			}
		}
		
		public void setText(String text){
			if (toDraw()){				
				Font font = new Font(getDisplay(),"Consolas",9, SWT.NONE); 
				// ... 
				getGC().setForeground(Colors.CYAN); 
				getGC().setFont(font); 
				//gc.drawText("Hello\tThere\nWide\tWorld",5,25);
				getGC().drawText(text, getX1()+10, getY1()-20);
				font.dispose();
				font = null;
				//Draw();
			}
		}
		
		public void setText(String text, Color color){
			if (toDraw()){				
				Font font = new Font(getDisplay(),"Consolas",9, SWT.NONE); 
				// ... 
				getGC().setForeground(color); 
				getGC().setFont(font); 
				//gc.drawText("Hello\tThere\nWide\tWorld",5,25);
				//getGC().drawText(text, getX1()+10, getY1()-15);
				getGC().drawText(text, getX1()+5, getY1()-20);
				font.dispose();
				font = null;
				//Draw();
			}
		}
		
		public int getWidth(){
			//return lineWidth;
			return getX2()-getX1();
		}
		
	}
	
	public class Unit extends Element{
		private int x;
		private int y;
		private int width;
		private int height;
		private int bottomY;
		private int bottomX;
		private int topY;
		private int topX;
	
		public Unit(int x, int y){
			super(getGC());
			this.x = x;
			this.width = 90;
			this.height = 30;
			this.y = y - this.height/2;
			this.bottomX = this.x+this.width/2;
			this.bottomY = this.y+this.height;
			this.topX = x+this.width/2;;
			this.topY = this.y;
			/*getGC().setLineWidth(2);
			getGC().setForeground(Colors.GRAY);
			Draw();*/
		}
		
		public int getWidth(){
			return width;
		}
		
		public int getHeight(){
			return height;
		}
		
		public void setWidth(int width) {
			this.width = width;
			
		}
		
		public void Draw(){
			
			getGC().drawRectangle(x, y, width, height);
		}
		
		public int getTopY(){
			return topY;
		}
		
		public int getTopX(){
			return topX;
		}
		
		public int getBottomY(){
			return bottomY;
		}
		
		public int getBottomX(){
			return bottomX;
		}
		
		public void setText(String text){
			
			Font font = new Font(getDisplay(),"Consolas",9, SWT.NONE); 
			getGC().setForeground(Colors.CYAN); 
			getGC().setFont(font);
			
			//Text t = new Text(null, bottomX);
		
			getGC().drawText(text, x+height/5, y+5);
			getGC().getFontMetrics().getAverageCharWidth();
			
			int textWidth = text.length()*getGC().getFontMetrics().getAverageCharWidth()+5;
			if ( textWidth >= getWidth()) {
				setWidth(textWidth+5);
			}
			
			getGC().setLineWidth(2);
			getGC().setForeground(Colors.GRAY);
			Draw();
			
			font.dispose();
			font = null;
			
		}
	
		public int getX1(){
			return x;
		}
		
		public int getY1(){
			return y;
		}
		public int getX2(){
			return x+width;
		}
		
		public int getY2(){
			return y+height/2;
		}
		
		public void setColor(Color color){
			//if (toDraw()){
				getGC().setForeground(color);
				Draw();
			//}
		}
	}
	public class CustomText extends Element{
		private int x1 = 0;
		private int y1 = 0;
		
		public CustomText(int x1,int y1){
			super(getGC());
			setX1(x1);
			setY1(y1);
			//setX2(x1+lineWidth);
			//setY2(y1);
			//setToDraw(true);
			//getGC().setForeground(Colors.GRAY);
			//Draw();
		}
		
		public void setX1(int x1){
			this.x1 = x1;
		}
		
		public void setY1(int y1){
			this.y1 = y1;
		}
		
		public int getY1(){
			return y1;
		}
		
		public int getX1(){
			return x1;
		}
		
		public void setText(String text, Color color){
			
			Font font = new Font(getDisplay(),"Consolas",9, SWT.NONE); 
			getGC().setForeground(color); 
			getGC().setFont(font); 
			getGC().drawText(text, getX1()+5, getY1()-10);
			font.dispose();
			font = null;
			
		}
	}
	
}
