package s.d.manager.scheme;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Rectangle;

import s.d.manager.model.Application;
import s.d.manager.model.Colors;
import s.d.manager.model.Request;
import s.d.manager.model.ups.PhaseParam;
import s.d.manager.scheme.Element.CustomText;
import s.d.manager.scheme.Element.Line;
import s.d.manager.scheme.Element.Unit;
import s.d.manager.views.Messages;

public class Scheme {
	private GC gc;
	private Element element;
	private int center;
	private Line input01;
	private Line input02;
	//private Line inputCommutator;
	private Line inputCommutator0;
	private Line inputCommutator1;
	private Unit rectifier;
	private Line middle0;
	private Line middle1;
	private Unit invertor;
	//private Line outputCommutator;
	private Line outputCommutator0;
	private Line outputCommutator1;
	private Line output01;
	private Line up;
	private Line upToBypass;
	private Rectangle clientArea;
	private Line output02;
	private Unit bypass;
	private Line upFromBypass;
	private Line upToOutput;
	private Unit battery;
	private Line downFromBattery;
	private final static int commutatorWidth = 40;
	//private ArrayList<Element> bypassStateList;
	//private ArrayList<Element> normalStateList;
	//private ArrayList<Element> batteryStateList;
	private ArrayList<Element> schemeElements;
	public Line[] input = new Line[3];
	public Line[] output = new Line[3];
	private ArrayList<Element> bypassLine;
	private ArrayList<Element> batteryLine;
	private ArrayList<Element> normalLine;
	private Line lineIsActive;
	private Line lineIsInActive;
	private Line lineNoConnection;
	private CustomText UpsState;
	static final Integer STATUS_NO_CONNECTION = 0;
	final static private Integer STATUS_OK = 1;
	final static private Integer STATUS_BYPASS = 2;
	final static private Integer STATUS_BATTERY = 3;
	final static private Integer STATUS_UPS_NOT_CONNECTED = 4;
	/*final static private Integer STATUS_BATTERY_PROBLEM = 3;
	final static private Integer STATUS_BATTERY_LOW = 4;*/
	private Messages messages;
	public Scheme(GC gc, Rectangle clientArea) {
		messages = Application.getInstance().messages;
		setGC(gc);
		this.clientArea = clientArea;
		center = clientArea.height/2 - clientArea.height / 5;
	}
	
	public void dispose() {
		getGC().dispose();
		element.dispose();
		lineIsActive.dispose();
		lineIsActive = null;
		lineIsInActive.dispose();
		lineIsInActive = null;
		lineNoConnection.dispose();
		lineNoConnection = null;
		UpsState.dispose();
		UpsState = null;
		for(Element element:getSchemeElements()){
			element.dispose();
			element = null;
		}
		bypassLine.clear();
		bypassLine = null;
		batteryLine.clear();
		batteryLine = null;
		normalLine.clear();
		normalLine = null;
	}

	public GC getGC() {
		return gc;
	}

	public void setGC(GC gc) {
		this.gc = gc;
	}
	
	public void setBackground(Color color) {
		getGC().setBackground(color);
	}
	
	public void Create(int phaseCount) {
		try	{
			
			element   = new Element(getGC());
			
			input[0] = element.new Line(0, center);
	        
			inputCommutator0 = element.new Line(input[0].getX2(), input[0].getY2(), input[0].getX2()+commutatorWidth/2, input[0].getY2());
			inputCommutator1 = element.new Line(inputCommutator0.getX2(), inputCommutator0.getY2(), inputCommutator0.getX2()+commutatorWidth/2, inputCommutator0.getY2());
			
	        rectifier = element.new Unit(inputCommutator1.getX2(), inputCommutator1.getY2());
	        rectifier.setText(messages.SchemeRectifier);
	        //rectifier.setWidth(130);
	        
	        middle0 = element.new Line(rectifier.getX2(), rectifier.getY2(), rectifier.getX2()+ commutatorWidth, rectifier.getY2());
	        middle1 = element.new Line(middle0.getX2(), middle0.getY2(), middle0.getX2()+ commutatorWidth, middle0.getY2());
	        
	        invertor = element.new Unit(middle1.getX2(), middle1.getY2());
	        invertor.setText(messages.SchemeInvertor);
	        
	        int unitPositionY = (input[0].getWidth() + rectifier.getHeight())/2;//     /  
	        
	        up = element.new Line(inputCommutator0.getX2(), inputCommutator0.getY2(), inputCommutator0.getX2(), center - unitPositionY);
	        
	        upToBypass = element.new Line(up.getX2(), up.getY2(), inputCommutator1.getX2()+rectifier.getWidth()/2+middle0.getWidth(), center-unitPositionY);
	        bypass = element.new Unit(upToBypass.getX2(), upToBypass.getY2());
	        
	        bypass.setText(messages.SchemeBypass);
	       
	        //outputCommutator0 = element.new Line(invertor.getX2(), invertor.getY2(), invertor.getX2() + commutatorWidth, invertor.getY2());
	        outputCommutator0 = element.new Line(invertor.getX2(), invertor.getY2(), invertor.getX2() + commutatorWidth/2, invertor.getY2());
	        outputCommutator1 = element.new Line(outputCommutator0.getX2(), outputCommutator0.getY2(), outputCommutator0.getX2()+commutatorWidth/2, invertor.getY2());
	        
	        upFromBypass = element.new Line(bypass.getX2(), bypass.getY2(), outputCommutator0.getX2(), bypass.getY2());
	       
	        upToOutput = element.new Line(upFromBypass.getX2(), upFromBypass.getY2(),upFromBypass.getX2(), center);
	        
	        
	        output[0] = element.new Line(outputCommutator1.getX2(),outputCommutator1.getY2(), clientArea.width, center);
	        
	        battery = element.new Unit(bypass.getX1(), center+unitPositionY);
	        battery.setText(messages.SchemeBattery);
	        
	        //downFromBattery = element.new Line(battery.getTopX(), battery.getTopY(), middle0.getX2(), middle0.getY2() );
	        downFromBattery = element.new Line(battery.getTopX(), battery.getTopY(), battery.getTopX(), middle0.getY2() );
	        if (phaseCount == 1 | phaseCount == 0) {
		        
		        input[1] = element.new Line(0, center+input[0].getWidth(), false);
		        input[2] = element.new Line(0, center-input[0].getWidth(), false);
		        
		        input01 = element.new Line(input[0].getX2(), input[0].getY2(), input[1].getX2(), input[1].getY2(), false);
		        input02 = element.new Line(input[1].getX2(), input[1].getY2(), input[2].getX2(), input[2].getY2(), false);
		        
		        output[1] = element.new Line(outputCommutator1.getX2(),outputCommutator1.getY2()+input[0].getWidth(), clientArea.width, outputCommutator1.getY2()+input[0].getWidth(), false);
		        output[2] = element.new Line(outputCommutator1.getX2(),outputCommutator1.getY2()-input[0].getWidth(), clientArea.width, outputCommutator1.getY2()-input[0].getWidth(), false);
		       
		        output01 = element.new Line(output[0].getX1(), output[0].getY1(), output[1].getX1(), output[1].getY1(), false);
		        output02 = element.new Line(output[0].getX1(), output[0].getY1(), output[2].getX1(), output[2].getY1(), false);
	        }
	        if (phaseCount == 3){
	        	input[1] = element.new Line(0, center+input[0].getWidth());
		        input[2] = element.new Line(0, center-input[0].getWidth());
		        
		        input01 = element.new Line(input[0].getX2(), input[0].getY2(), input[1].getX2(), input[1].getY2());
		        input02 = element.new Line(input[1].getX2(), input[1].getY2(), input[2].getX2(), input[2].getY2());
		        
		        output[1] = element.new Line(outputCommutator1.getX2(),outputCommutator1.getY2()+input[0].getWidth(), clientArea.width, outputCommutator1.getY2()+input[0].getWidth());
		        output[2] = element.new Line(outputCommutator1.getX2(),outputCommutator1.getY2()-input[0].getWidth(), clientArea.width, outputCommutator1.getY2()-input[0].getWidth());
		       
		        output01 = element.new Line(output[0].getX1(), output[0].getY1(), output[1].getX1(), output[1].getY1());
		        output02 = element.new Line(output[0].getX1(), output[0].getY1(), output[2].getX1(), output[2].getY1());
	        }
	        
	        UpsState = element.new CustomText(0, input[1].getY2()+input[1].getWidth()/4+15);
	        UpsState.setText(messages.SchemeOperatingMode, Colors.CYAN);
	        
	        CustomText upsNotation = element.new CustomText(0, UpsState.getY1()+input[1].getWidth()/4+15);
	        upsNotation.setText(messages.SchemeNotation, Colors.CYAN);
	        
	        //lineIsActive = element.new Line(0, center+2*input[0].getWidth());
	        lineIsActive = element.new Line(0, upsNotation.getY1()+input[0].getWidth()/2+5);
	        lineIsActive.setText(messages.SchemeLineIsActive, Colors.LIGHT_GREEN);
	        lineIsActive.setColor(Colors.LIGHT_GREEN);
	       
	        lineIsInActive = element.new Line(0, lineIsActive.getY2()+input[0].getWidth()/2);
	        lineIsInActive.setText(messages.SchemeLineIsInactive, Colors.GRAY);
	        lineIsInActive.setColor(Colors.GRAY);
	        
	        lineNoConnection = element.new Line(0, lineIsInActive.getY2()+input[0].getWidth()/2);
	        lineNoConnection.setText(messages.SchemeNoConnection, Colors.GRAY);
	        lineNoConnection.setColor(Colors.GRAY);
	        
	        Line problem = element.new Line(0, lineNoConnection.getY2()+input[0].getWidth()/2);
	        problem.setText(messages.SchemeProblem, Colors.ORANGE);
	        problem.setColor(Colors.ORANGE);
	        // arrayList c  
	        setBypassLine(); //      
            setBatteryLine();//        
            setNormalLine();//       
            setSchemeElements();//    
        
		} catch (Exception e) {
			
		}
	}
	
	public void redraw(Request request) {
		messages = Application.getInstance().messages;
		try {
		if (request != null) {
			//System.out.println(" = " + request.getBatteryProblemFlag());
			if (getStatus(request) == STATUS_NO_CONNECTION) {
				setInputVoltage(null);
				setOutputVoltage(null);
				setSchemeColor(getSchemeElements(), Colors.GRAY); //    
				getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.SchemeNoConnection, Colors.ORANGE);
				return;
			}
			
			if (getStatus(request) == STATUS_UPS_NOT_CONNECTED) {
				setInputVoltage(null);
				setOutputVoltage(null);
				setSchemeColor(getSchemeElements(), Colors.GRAY); //    
				//getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.SchemeNoConnection, Colors.ORANGE);
				getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.AlarmUpsNotConnected, Colors.ORANGE);
				return;
			}
			
			if (getStatus(request) == STATUS_OK) {
				setInputVoltage(request.getUps().getPhaseParams());
				setOutputVoltage(request.getUps().getPhaseParams());
				setSchemeColor(getSchemeElements(), Colors.GRAY);//    
				setSchemeColor(getNormalLine(), Colors.LIGHT_GREEN);//   
				setSchemeColor(getBatteryLine(), Colors.LIGHT_GREEN);//   
				getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.SchemeModeOnLine, Colors.CYAN);
				try {
					if (request.getUps().getUpsParams().getUpsBatteryAlarmFlag() == 1) {
						//System.out.println(" ");
						getBattery().setColor(Colors.ORANGE);
						getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.BatteryStateProblem, Colors.ORANGE);
					}
					
					if (request.getUps().getUpsParams().getUpsBatteryLowFlag() == 1 & request.getUps().getUpsParams().getUpsBatteryAlarmFlag() == 1) {
						getBattery().setColor(Colors.ORANGE);
						getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.BatteryStateLow, Colors.ORANGE);
					}
					
					if (request.getUps().getUpsParams().getUpsBatteryLowFlag() == 1) {
						getBattery().setColor(Colors.ORANGE);
						getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.BatteryStateLow, Colors.ORANGE);
					}
										
				} catch (Exception e) {
					
				}
				return;
			}		
			if (getStatus(request) == STATUS_BYPASS) {
				try {
					setInputVoltage(request.getUps().getPhaseParams());
					setOutputVoltage(request.getUps().getPhaseParams());
					setSchemeColor(getSchemeElements(), Colors.GRAY);//    
					setSchemeColor(getBypassLine(), Colors.LIGHT_GREEN);//   
					getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.SchemeModeBypass, Colors.CYAN);
					if (request.getUps().getUpsParams().getUpsBatteryAlarmFlag() == 1) {
						//System.out.println(" ");
						getBattery().setColor(Colors.ORANGE);
						getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.BatteryStateProblem, Colors.ORANGE);
					}
					
					if (request.getUps().getUpsParams().getUpsBatteryLowFlag() == 1 & request.getUps().getUpsParams().getUpsBatteryAlarmFlag() == 1) {
						getBattery().setColor(Colors.ORANGE);
						getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.BatteryStateLow, Colors.ORANGE);
					}
					
					if (request.getUps().getUpsParams().getUpsBatteryLowFlag() == 1) {
						getBattery().setColor(Colors.ORANGE);
						getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.BatteryStateLow, Colors.ORANGE);
					}
				} catch (Exception e) {
					
				}
				return;
			}
			
			if (getStatus(request) == STATUS_BATTERY) {
				try {
					setInputVoltage(request.getUps().getPhaseParams());
					setOutputVoltage(request.getUps().getPhaseParams());
					setSchemeColor(getSchemeElements(), Colors.GRAY);//    
					setSchemeColor(getBatteryLine(), Colors.LIGHT_GREEN);//   
					getUpsStateText().setText(messages.SchemeOperatingMode +" "+ messages.SchemeModeBattery, Colors.CYAN);
				} catch (Exception e) {
					
				}
				return;
			}

		}

		} catch (Exception e) {
		
		}
	}
	
	public Integer getStatus(Request request) {
		int status = 0;
		if (request != null) {
			if (request.isFailed()) {
				status = STATUS_NO_CONNECTION;
			} else {
				status = STATUS_OK;
			}
		
			if (request.getUps().getUpsParams() != null) {
				
				if (request.getUps().getUpsParams().getUpsConnectedFlag() == 0) {
					status = STATUS_UPS_NOT_CONNECTED;				
				} else
				
				if (request.getUps().getUpsParams().getUpsBypassStatusFlag() == 1) {
					status = STATUS_BYPASS;
					
				} else
				if (request.getUps().getUpsParams().getUpsInVoltageFlag() == 1) {
					status = STATUS_BATTERY;
					
				}
				
			} else {
				status = STATUS_NO_CONNECTION;
			}
			
		}

		return status;
	}
	
	public Line[] getInput() {
		return input;
	}
	
	/*public void setInputVoltage(String values[][]) {
		if (values != null) {
			for (int i = 0; i < values.length; i++) {
				if (input[i].toDraw()) {
					if (input[i] != null) {
						input[i].setText(values[i][1]);
					}
				}
			}
		} else {
			for (int i = 0; i < 3; i++) {
				if (input[i] != null) {
					if (input[i].toDraw()) {				
						input[i].setText("n/a");
					}
				}
			}
		}
	}*/
	
	public void setInputVoltage(List<PhaseParam> phaseParams) {
		if (phaseParams != null) {
			for (int i = 0; i<phaseParams.size(); i++) {
				if (input[i].toDraw()) {
					if (input[i] != null) {
						input[i].setText(phaseParams.get(i).getUpsPhaseInVoltage());
					}
				}
			}
		} else {
			for (int i = 0; i < 3; i++) {
				if (input[i] != null) {
					if (input[i].toDraw()) {				
						input[i].setText("n/a");
					}
				}
			}
		}
	}
	
	/*public void setOutputVoltage(String values[][]) {
		if (values != null) {
			for (int i = 0; i < values.length; i++) {
				if (output[i].toDraw()) {
					if (output[i] != null) {
						output[i].setText(values[i][3]);
					}
				}
			}
		} else {
			for (int i = 0; i < 3; i++) {
				if (output[i] != null) {
					if (output[i].toDraw()) {
						output[i].setText("n/a");
					}
				}
			}
		}
	}*/
	
	public void setOutputVoltage(List<PhaseParam> phaseParams) {
		if (phaseParams != null) {
			for (int i = 0; i<phaseParams.size(); i++) {
				if (output[i].toDraw()) {
					if (output[i] != null) {
						output[i].setText(phaseParams.get(i).getUpsPhaseOutVoltage());
					}
				}
			}
		} else {
			for (int i = 0; i < 3; i++) {
				if (output[i] != null) {
					if (output[i].toDraw()) {				
						output[i].setText("n/a");
					}
				}
			}
		}
	}
	
	public void setSchemeElements() {
		ArrayList<Element> list = new ArrayList<Element>();
		for (int i = 0; i < 3; i++) {
			if (input[i] != null) {
				list.add(input[i]);
			}
		}
		for (int i = 0; i < 3; i++) {
			if (output[i] != null) {
				list.add(output[i]);
			}
		}
		list.add(input01);
		list.add(input02);
		list.add(output01);
		list.add(output02);
		list.add(inputCommutator0);
		list.add(inputCommutator1);
		list.add(middle0);
		list.add(middle1);
		list.add(rectifier);
		list.add(invertor);
		list.add(outputCommutator0);
		list.add(outputCommutator1);
		list.add(bypass);
		list.add(up);
		list.add(upToBypass);
		list.add(upFromBypass);
		list.add(upToOutput);
		list.add(battery);
		list.add(downFromBattery);
		schemeElements = list;
		list = null;
	}
	
	public ArrayList<Element> getSchemeElements(){
		return schemeElements;
	}
	
	public void setBypassLine(){
		if (bypassLine != null) {
			bypassLine.clear();
		}
		ArrayList<Element> list = new ArrayList<Element>();
		for (int i = 0; i<input.length; i++){
			list.add(input[i]);
		}
		list.add(input01);
		list.add(input02);
		list.add(inputCommutator0);
		list.add(bypass);
		list.add(up);
		list.add(upToBypass);
		list.add(upFromBypass);
		list.add(upToOutput);
		list.add(output01);
		list.add(output02);
		//list.add(outputCommutator0);
		list.add(outputCommutator1);
		for (int i = 0; i < 3; i++) {
			if (output[i] != null) {
				list.add(output[i]);
			}
		}
		bypassLine = list;
		list = null;
	}
	
	public CustomText getUpsStateText(){
		return UpsState;
	}
	
	public Unit getBattery(){
		return battery;
	}
	public void setBatteryLine(){
		if (batteryLine != null) {
			batteryLine.clear();
		}
		ArrayList<Element> list = new ArrayList<Element>();
		list.add(battery);
		list.add(downFromBattery);
		list.add(invertor);
		list.add(middle1);
		list.add(outputCommutator0);
		list.add(outputCommutator1);
		list.add(output01);
		list.add(output02);
		
		for (int i = 0; i < 3; i++) {
			//if (output[i] != null) {
				list.add(output[i]);
			//}
		}
		batteryLine = list;
		list = null;
	}
	
	public void setNormalLine(){
		if (normalLine != null) {
			normalLine.clear();
		}
		ArrayList<Element> list = new ArrayList<Element>();
		for (int i = 0; i < 3; i++) {
			if (input[i] != null) {
				list.add(input[i]);
			}
		}
		for (int i = 0; i < 3; i++) {
			if (output[i] != null) {
				list.add(output[i]);
			}
		}
		list.add(input01);
		list.add(input02);
		list.add(output01);
		list.add(output02);
		list.add(inputCommutator0);
		list.add(inputCommutator1);
		list.add(middle0);
		list.add(middle1);
		list.add(rectifier);
		list.add(invertor);
		list.add(outputCommutator0);
		list.add(outputCommutator1);
		normalLine = list;
		list = null;
	}
	
	public ArrayList<Element> getBypassLine(){
		return bypassLine;
	}
	
	public ArrayList<Element> getBatteryLine(){
		return batteryLine;
	}
	
	public ArrayList<Element> getNormalLine(){
		return normalLine;
	}
		
	public void setSchemeColor(final ArrayList<Element> list, final Color color){
		if (list != null){
			for (int i = 0; i < list.size(); i++) {
				if (list.get(i).getClass() == Element.Line.class) {
					if (list.get(i) != null){
						//if (((Line) list.get(i)).toDraw()){
						if (((Line) list.get(i)).toDraw()){
							((Line) list.get(i)).setColor(color);
						}
					}
				}
				if (list.get(i).getClass() == Element.Unit.class) {
					if (list.get(i) != null){
						((Unit) list.get(i)).setColor(color);
					}
				}
			}
		}
	}
	
	public void switchSchemeColor(final ArrayList<Element> list, final Color color){
		if (list != null){
			for (int i = 0; i < getSchemeElements().size(); i++) {
				for (int j = 0; j < list.size(); j++) {
					if (getSchemeElements().get(i) != list.get(j)){
						//getSchemeElements().get(i).setColor(Colors.GREEN);
						if (( getSchemeElements().get(i)).getClass() == Element.Line.class) {
								if (((Line) getSchemeElements().get(i)).toDraw()){
									((Line) getSchemeElements().get(i)).setColor(Colors.GREEN);
								}
							}
						if (( getSchemeElements().get(i)).getClass() == Element.Unit.class) {
							((Unit) getSchemeElements().get(i)).setColor(Colors.LIGHT_GREEN);
						}
						
					} else {
						getSchemeElements().get(i).setColor(color);
					}
				}
			}
		}
	}
	
}
