package s.d.manager.views;

import java.util.ArrayList;
import java.util.List;
import java.util.Map.Entry;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.ui.di.UIEventTopic;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.UIEvents;
import org.eclipse.e4.ui.workbench.UIEvents.EventTags;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Table;
import org.osgi.service.event.Event;

import s.d.manager.dialogs.DialogOpenAccess;
import s.d.manager.model.Application;
import s.d.manager.model.EventConstants;
import s.d.manager.model.Gui;
import s.d.manager.model.ups.Ups;
public class ClimatControl {
	
	
	private Gui gui = new Gui();
	private Table climatControl_1_Inputs;
	private Table climatControl_2_Inputs;
	private Table climatControl_1_Outputs;
	private Table climatControl_2_Outputs;
	private Label climatControl_1_T1_label;
	private Label climatControl_1_T2_label;
	private Label climatControl_1_Humidity_label;
	private Label climatControl_1_FanTempLow_label;
	private Label climatControl_1_FanTempHigh_label;
	private Label climatControl_1_FanTempPower_label;
	
	private Label climatControl_2_T1_label;
	private Label climatControl_2_T2_label;
	private Label climatControl_2_Humidity_label;
	private Label climatControl_2_FanTempLow_label;
	private Label climatControl_2_FanTempHigh_label;
	private Label climatControl_2_FanTempPower_label;
	
	private List<Label> alarmLables = new ArrayList<Label>();
	private Group climatControl_2_FanGroup;
	private Group climatControl_1_FanGroup;
	private MPart part;
	private Composite parent;
	private Button climaticSettingsButton;
	
	
	@PostConstruct
	public void createControls(final Composite parent1, final MPart part) {

		
		final ScrolledComposite sc = new ScrolledComposite(parent1, SWT.V_SCROLL);
		   
		parent = new Composite(sc, SWT.NONE);
		
	    sc.setContent(parent);
	    sc.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
	    sc.setExpandHorizontal(true);
	    
	    parent.setLayout(new GridLayout(1, false));
		this.part = part;
		createClimatControl1Group(parent);
		createClimatControl2Group(parent);   
		parent.pack();
	}
	
	public void createClimatControl1Group(Composite parent) {
		
		Group group = new Group(parent, SWT.NONE);
		group.setText("  1");
		
		group.setLayout(new GridLayout(1, true));
		group.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		final Composite composite = new Composite(group, SWT.NONE);
		composite.setLayout(new GridLayout(4, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		climatControl_1_Inputs= createTableComposite(composite, climatControl_1_Inputs, "1", "", "", "","");
		
		climatControl_1_Inputs.setLayout(new GridLayout(1, false));
		GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true);
		gd.minimumWidth = 350;
		climatControl_1_Inputs.setLayoutData(gd);
		climatControl_1_Outputs = createTableComposite(composite, climatControl_1_Outputs, "1", "", "");
		//createClimatControl_1_FanComposite(composite);
		
		
		final Composite composite2 = new Composite(composite, SWT.NONE);
		composite2.setLayout(new GridLayout(2, false));
		//composite2.setLayout(parent.getLayout());
		composite2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		createClimatControl_1_FanComposite(composite2);
		//climatControl_1_Outputs = createTableComposite(composite2, climatControl_1_Outputs, "1", "", "");
		
		/*final Composite composite3 = new Composite(composite2, SWT.NONE);
		composite3.setLayout(new GridLayout(1, false));
		composite3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));*/
		
		createClimatControl_1_TemperatureComposite(composite2);
		createClimatControl_1_HumiditiesComposite(composite2);
		createClimateControlSettingsComposite(composite2);
		createClimateControlAlarmsComposite(composite2);
		composite.pack();
	}
	
	public void createClimatControl2Group(Composite parent) {
		
		Group group = new Group(parent, SWT.NONE);
		group.setText("  2");
		
		group.setLayout(new GridLayout(1, false));
		group.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		final Composite composite = new Composite(group, SWT.NONE);
		composite.setLayout(new GridLayout(4, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		climatControl_2_Inputs = createTableComposite(composite, climatControl_2_Inputs, "2", "", "", "","");
		climatControl_2_Outputs = createTableComposite(composite, climatControl_2_Outputs,"2", "", "");
		createClimatControl_2_FanComposite(composite);
		
		final Composite composite2 = new Composite(composite, SWT.NONE);
		composite2.setLayout(new GridLayout(2, false));
		//composite2.setLayout(parent.getLayout());
		composite2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		
		/*final Composite composite3 = new Composite(composite2, SWT.NONE);
		composite3.setLayout(new GridLayout(1, false));
		composite3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));*/
		
		createClimatControl_2_TemperatureComposite(composite2);
		createClimatControl_2_HumiditiesComposite(composite2);
		
		composite.pack();
	}	
	
	public void createClimateControlSettingsComposite(Composite parent) {
		
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Group group = new Group(composite, SWT.NONE);
		group.setText("");
		group.setLayout(getGridLayout());
		group.setLayoutData(getGridData());
	
		climaticSettingsButton = new Button(group, SWT.PUSH);
		climaticSettingsButton.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false, 1,1));
		climaticSettingsButton.setText("  ");
		climaticSettingsButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				DialogOpenAccess dialogAccess = new DialogOpenAccess();
				dialogAccess.openToSetClimaticSettings();
			}
		});
		climaticSettingsButton.setEnabled(false);
	}
	
	public void createClimateControlAlarmsComposite(Composite parent) {
		Group group = new Group(parent, SWT.NONE);
		group.setText(" ");
		
		group.setLayout(new GridLayout(1, false));
		group.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		final Composite composite = new Composite(group, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Label label1 = new Label(composite, SWT.NONE);
		label1.setText(" !");
		
		Label label2 = new Label(composite, SWT.NONE);
		label2.setText("  !");
		
		Label label3 = new Label(composite, SWT.NONE);
		label3.setText(" !");
		
		Label label4 = new Label(composite, SWT.NONE);
		label4.setText("!");
		
		Label label5 = new Label(composite, SWT.NONE);
		label5.setText(" !");
		
		Label label6 = new Label(composite, SWT.NONE);
		label6.setText(" !");
		
		Label label7 = new Label(composite, SWT.NONE);
		label7.setText("");
		
		Label label8 = new Label(composite, SWT.NONE);
		label8.setText(" !");
		
		Label label9 = new Label(composite, SWT.NONE);
		label9.setText(" !");
		
		Label label10 = new Label(composite, SWT.NONE);
		label10.setText("!");
		
		alarmLables.add(label1);
		alarmLables.add(label2);
		alarmLables.add(label3);
		alarmLables.add(label4);
		alarmLables.add(label5);
		alarmLables.add(label6);
		alarmLables.add(label7);
		alarmLables.add(label8);
		alarmLables.add(label9);
		alarmLables.add(label10);
		
	}
	
	private void setAlarmLabelsDisabled() {
		for(Label label:alarmLables)
			label.setEnabled(false);
			
	}
	
	public Table createTableComposite(Composite parent, Table table, String tableText, String... columnNames) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		Group tableGroup = new Group(composite, SWT.NONE);
		tableGroup.setText(tableText);
		
		tableGroup.setLayout(new GridLayout(1, false));
		tableGroup.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
	
		gui.setComposite(tableGroup);
		table = gui.createTable(columnNames);
		table.setLayout(new GridLayout(1, false));
		
		GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true);
	
		table.setLayoutData(gd);
		table.pack();
		composite.pack();
		return table;
	}
	
	public void createClimatControl_1_TemperatureComposite(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Group climatControlTemperatureGroup = new Group(composite, SWT.NONE);
		climatControlTemperatureGroup.setText(" ");
		climatControlTemperatureGroup.setLayout(getGridLayout());
		climatControlTemperatureGroup.setLayoutData(getGridData());
		
		Label climatControl_1_T1 = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_1_T1.setText("1"); //$NON-NLS-1$
		climatControl_1_T1_label = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_1_T1_label.setText(""); //$NON-NLS-1$
		
		Label climatControl_1_T2 = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_1_T2.setText("2"); //$NON-NLS-1$
		climatControl_1_T2_label = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_1_T2_label.setText(""); //$NON-NLS-1$
		composite.pack();
	}
	
	public void createClimatControl_1_HumiditiesComposite(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Group climatControlTemperatureGroup = new Group(composite, SWT.NONE);
		climatControlTemperatureGroup.setText("");
		climatControlTemperatureGroup.setLayout(getGridLayout());
		climatControlTemperatureGroup.setLayoutData(getGridData());
		
		Label climatControl_1_Humidity = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_1_Humidity.setText(""); //$NON-NLS-1$
		climatControl_1_Humidity_label = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_1_Humidity_label.setText(""); //$NON-NLS-1$
		
		composite.pack();
	}
	
	public void createClimatControl_1_FanComposite(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, false, false, 1, 1));
		
		climatControl_1_FanGroup = new Group(composite, SWT.NONE);
		climatControl_1_FanGroup.setText("");
		climatControl_1_FanGroup.setLayout(getGridLayout());
		climatControl_1_FanGroup.setLayoutData(getGridData());
		
		Label climatControl_1_FanTempLow = new Label(climatControl_1_FanGroup, SWT.NONE);
		climatControl_1_FanTempLow.setText(" "); //$NON-NLS-1$
		climatControl_1_FanTempLow_label = new Label(climatControl_1_FanGroup, SWT.NONE);
		climatControl_1_FanTempLow_label.setText(""); //$NON-NLS-1$
		
		Label climatControl_1_FanTempHigh = new Label(climatControl_1_FanGroup, SWT.NONE);
		climatControl_1_FanTempHigh.setText(" "); //$NON-NLS-1$
		climatControl_1_FanTempHigh_label = new Label(climatControl_1_FanGroup, SWT.NONE);
		climatControl_1_FanTempHigh_label.setText(""); //$NON-NLS-1$
		
		Label climatControl_1_FanTempPower = new Label(climatControl_1_FanGroup, SWT.NONE);
		climatControl_1_FanTempPower.setText(""); //$NON-NLS-1$
		climatControl_1_FanTempPower_label = new Label(climatControl_1_FanGroup, SWT.NONE);
		climatControl_1_FanTempPower_label.setText(""); //$NON-NLS-1$
		
		composite.pack();
	}
	
	public void createClimatControl_2_TemperatureComposite(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Group climatControlTemperatureGroup = new Group(composite, SWT.NONE);
		climatControlTemperatureGroup.setText(" ");
		climatControlTemperatureGroup.setLayout(getGridLayout());
		climatControlTemperatureGroup.setLayoutData(getGridData());
		
		Label climatControl_2_T1 = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_2_T1.setText("1"); //$NON-NLS-1$
		climatControl_2_T1_label = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_2_T1_label.setText(""); //$NON-NLS-1$
		
		Label climatControl_2_T2 = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_2_T2.setText("2"); //$NON-NLS-1$
		climatControl_2_T2_label = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_2_T2_label.setText(""); //$NON-NLS-1$
		composite.pack();
	}
	
	public void createClimatControl_2_HumiditiesComposite(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1));
		
		Group climatControlTemperatureGroup = new Group(composite, SWT.NONE);
		climatControlTemperatureGroup.setText("");
		climatControlTemperatureGroup.setLayout(getGridLayout());
		climatControlTemperatureGroup.setLayoutData(getGridData());
		
		Label climatControl_2_Humidity = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_2_Humidity.setText(""); //$NON-NLS-1$
		climatControl_2_Humidity_label = new Label(climatControlTemperatureGroup, SWT.NONE);
		climatControl_2_Humidity_label.setText(""); //$NON-NLS-1$
		
		composite.pack();
	}
	
	public void createClimatControl_2_FanComposite(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		//composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.TOP, false, false, 1, 1));
		
		climatControl_2_FanGroup = new Group(composite, SWT.NONE);
		climatControl_2_FanGroup.setText("");
		climatControl_2_FanGroup.setLayout(getGridLayout());
		climatControl_2_FanGroup.setLayoutData(getGridData());
		
		Label climatControl_2_FanTempLow = new Label(climatControl_2_FanGroup, SWT.NONE);
		climatControl_2_FanTempLow.setText(" "); //$NON-NLS-1$
		climatControl_2_FanTempLow_label = new Label(climatControl_2_FanGroup, SWT.NONE);
		climatControl_2_FanTempLow_label.setText(""); //$NON-NLS-1$
		
		Label climatControl_2_FanTempHigh = new Label(climatControl_2_FanGroup, SWT.NONE);
		climatControl_2_FanTempHigh.setText(" "); //$NON-NLS-1$
		climatControl_2_FanTempHigh_label = new Label(climatControl_2_FanGroup, SWT.NONE);
		climatControl_2_FanTempHigh_label.setText(""); //$NON-NLS-1$
		
		Label climatControl_2_FanTempPower = new Label(climatControl_2_FanGroup, SWT.NONE);
		climatControl_2_FanTempPower.setText(""); //$NON-NLS-1$
		climatControl_2_FanTempPower_label = new Label(climatControl_2_FanGroup, SWT.NONE);
		climatControl_2_FanTempPower_label.setText(""); //$NON-NLS-1$
		
		composite.pack();
	}
	
	public GridLayout getGridLayout() {
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		//gridLayout.marginWidth = 2;
		return gridLayout;
	}
	
	public GridData getGridData() {
		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
	    gridData.horizontalSpan= 2;
	    //gridData.minimumWidth = appWidth-50;
		return gridData;
	    
	}
	
	@Inject @Optional
	public void HandlerTefreshAlarms(@UIEventTopic(EventConstants.REFRESH_CLIMATIC_CONTROL) final Ups ups) {
		//gui.clearTable(phaseParamsTable);
		if (ups.getClimatControl() != null) {
			//if (ups.getUpsParams().getUpsConnectedFlag() != 0 ) {
				//gui.fillPhaseParamsTable(null, phaseParamsTable);
			climaticSettingsButton.setEnabled(true);
			fillaAlarmsGroup(ups);
			fillTempararureGroups(ups);
			fillHumiditiesGroups(ups);
			fillFanGroups(ups);
			
			try {
				gui.clearTable(climatControl_1_Inputs);
				gui.clearTable(climatControl_2_Inputs);
				gui.clearTable(climatControl_1_Outputs);
				gui.clearTable(climatControl_2_Outputs);
				
				if (ups.getClimatControl().CLIMAT_CONTROL_UNIT_1_CONNECT == 1) {
					gui.fillClimaticInputTable(ups.getClimatControl().getClimatControl_1_InputsTable(), climatControl_1_Inputs);	
					gui.fillClimaticOutputTable(ups.getClimatControl().getClimatControl_1_OutputsTable(), climatControl_1_Outputs);
				}
				
				if (ups.getClimatControl().CLIMAT_CONTROL_UNIT_2_CONNECT == 1) {
					gui.fillClimaticInputTable(ups.getClimatControl().getClimatControl_2_InputsTable(), climatControl_2_Inputs);							
					gui.fillClimaticOutputTable(ups.getClimatControl().getClimatControl_2_OutputsTable(), climatControl_2_Outputs);
				}
				
				gui.packColumns(climatControl_1_Inputs);
				gui.packColumns(climatControl_2_Inputs);
				gui.packColumns(climatControl_1_Outputs);
				gui.packColumns(climatControl_2_Outputs);
			} catch (Exception e) {
				
			}
				   
			//}
		} else {
			
			climaticSettingsButton.setEnabled(false);
			
			setAlarmLabelsDisabled();
			
			disableLabel(climatControl_1_Humidity_label);
			disableLabel(climatControl_2_Humidity_label);
			
			disableLabel(climatControl_1_T1_label);
			disableLabel(climatControl_1_T2_label);
			disableLabel(climatControl_2_T1_label);
			disableLabel(climatControl_2_T2_label);
			
			disableGroup(climatControl_1_FanGroup);
			disableGroup(climatControl_2_FanGroup);
			
			gui.clearTable(climatControl_1_Inputs);
			gui.clearTable(climatControl_2_Inputs);
			gui.clearTable(climatControl_1_Outputs);
			gui.clearTable(climatControl_2_Outputs);
		}
		parent.pack();
	}
	public void setLabelColor(final Label label, final Integer color){
		try {
			Display.getDefault().asyncExec(new Runnable() {
		          public void run() {
		        	  label.setForeground(Display.getDefault().getSystemColor(color));
		        	  label.pack();
		          }
			});
		} catch (Exception e) {
			 //log.log(Level.SEVERE, "Exception: ", e);
		}
			
	}
	
	public void disableLabel(Label label) {
		label.setText("n/a");
		label.setEnabled(false);
	}
	
	public void enableLabel(Label label, String text) {
		label.setText(text);
		label.setEnabled(true);
	}
	
	public void fillTempararureGroups(Ups ups) {
		try {
			if (ups.getClimatControl().getClimatControl_1_T1Presence()!=null) {
				if (ups.getClimatControl().getClimatControl_1_T1Presence()==1) {
					try {
						enableLabel(climatControl_1_T1_label, String.valueOf((double)ups.getClimatControl().getCLIMAT_CONTROL_1_T1()/10)+ "\u00B0");
					}
					catch (Exception e) {
						disableLabel(climatControl_1_T1_label);
					}
				} else {
					disableLabel(climatControl_1_T1_label);
				}
			}
			
			if (ups.getClimatControl().getClimatControl_1_T2Presence()!=null) {
				if (ups.getClimatControl().getClimatControl_1_T2Presence()==1) {
					try {
						enableLabel(climatControl_1_T2_label, String.valueOf((double)ups.getClimatControl().getCLIMAT_CONTROL_1_T2()/10)+ "\u00B0");
					}
					catch (Exception e) {
						disableLabel(climatControl_1_T2_label);
					}	
				} else {
					disableLabel(climatControl_1_T2_label);
				}
			}
			
			if (ups.getClimatControl().getClimatControl_2_T1Presence()!=null) {		
				if (ups.getClimatControl().getClimatControl_2_T1Presence()==1) {
					try {
						enableLabel(climatControl_2_T1_label, String.valueOf((double)ups.getClimatControl().getCLIMAT_CONTROL_2_T1()/10)+ "\u00B0");
					}
					catch (Exception e) {
						disableLabel(climatControl_2_T1_label);
					}
				} else {
					disableLabel(climatControl_2_T1_label);
				}
			}
			
			if (ups.getClimatControl().getClimatControl_2_T2Presence()!=null) {
				if (ups.getClimatControl().getClimatControl_2_T2Presence()==1) {
					try {
						enableLabel(climatControl_2_T2_label, String.valueOf((double)ups.getClimatControl().getCLIMAT_CONTROL_2_T2()/10)+ "\u00B0");
					}
					catch (Exception e) {
						disableLabel(climatControl_2_T2_label);
					}
				} else {
					disableLabel(climatControl_2_T2_label);
				}
			}
		
		} catch (Exception e) {
			
		}
	}
	
	public void fillaAlarmsGroup(Ups ups) {
		try {
			setAlarmLabelsDisabled();
			int i=0;
			for(Entry<String, Integer> entry : ups.getClimatControl().getClimatControlAlarmsValues().entrySet()) {
				Integer value = entry.getValue();
				//System.out.println(key + " => " + value);
				
				if (value!=null) {
					if (value==1) {
						alarmLables.get(i).setEnabled(true);
						setLabelColor(alarmLables.get(i), SWT.COLOR_RED);
					}
				}
				i+=1;
			}
		} catch (Exception e) {
			
		}
	}
	
	public void fillHumiditiesGroups(Ups ups) {
		try {
			if (ups.getClimatControl().getCLIMAT_CONTROL_1_H1Presence()!=null) {
				if (ups.getClimatControl().getCLIMAT_CONTROL_1_H1Presence()==1) {
					enableLabel(climatControl_1_Humidity_label, String.valueOf((ups.getClimatControl().getCLIMAT_CONTROL_1_H1())) + "%");
				} else {
					disableLabel(climatControl_1_Humidity_label);
				}
			}
			
			if (ups.getClimatControl().getCLIMAT_CONTROL_2_H1Presence()!=null) {
				if (ups.getClimatControl().getCLIMAT_CONTROL_2_H1Presence()==1) {
					enableLabel(climatControl_2_Humidity_label, String.valueOf((ups.getClimatControl().getCLIMAT_CONTROL_2_H1())) + "%");
				} else {
					disableLabel(climatControl_1_Humidity_label);
				}
			}
		} catch (Exception e) {
			
		}
	}
	
	public void fillFanGroups(Ups ups) {
		try {
			if (ups.getClimatControl().getCLIMAT_CONTROL_1_FAN_PRESENCE()!=null) {
				if (ups.getClimatControl().getCLIMAT_CONTROL_1_FAN_PRESENCE()==1) {
					enableGroup(climatControl_1_FanGroup);
					enableLabel(climatControl_1_FanTempLow_label, String.valueOf((ups.getClimatControl().getCLIMAT_CONTROL_1_FAN_TEMP_LOW())));
					enableLabel(climatControl_1_FanTempHigh_label, String.valueOf((ups.getClimatControl().getCLIMAT_CONTROL_1_FAN_TEMP_HIGH())));
					enableLabel(climatControl_1_FanTempPower_label, String.valueOf((ups.getClimatControl().getCLIMAT_CONTROL_1_FAN_POWER())));
				} else {
					disableGroup(climatControl_1_FanGroup);
				}
			}
			
			if (ups.getClimatControl().getCLIMAT_CONTROL_2_FAN_PRESENCE()!=null) {
				if (ups.getClimatControl().getCLIMAT_CONTROL_2_FAN_PRESENCE()==1) {
					enableGroup(climatControl_2_FanGroup);
					enableLabel(climatControl_2_FanTempLow_label, String.valueOf((ups.getClimatControl().getCLIMAT_CONTROL_2_FAN_TEMP_LOW())));
					enableLabel(climatControl_2_FanTempHigh_label, String.valueOf((ups.getClimatControl().getCLIMAT_CONTROL_2_FAN_TEMP_HIGH())));
					enableLabel(climatControl_2_FanTempPower_label, String.valueOf((ups.getClimatControl().getCLIMAT_CONTROL_2_FAN_POWER())));
				} else {
					disableGroup(climatControl_2_FanGroup);
				}
			}
		} catch (Exception e) {
			
		}
	}
	
	public void disableGroup(Group group) {
		try {
			int i=0;
			for (Control control:group.getChildren()) {
				if (i % 2 != 0) {
					control.setEnabled(false);
					((Label) control).setText("n/a");
				}
				i++;
			}
		} catch (Exception e) {
			
		}
	}
	
	public void enableGroup(Group group) {
		try {
			for (Control control:group.getChildren()) {
				control.setEnabled(true);
			}
		} catch (Exception e) {
			
		}
	}

	@Inject
	@Optional
	public void subscribeTopicPartActivation(@UIEventTopic(UIEvents.UILifeCycle.ACTIVATE) Event event) {
	  
	  Object element = event.getProperty(EventTags.ELEMENT);
	  if (!(element instanceof MPart)) {
	    return;
	  }
	  
	  MPart part = (MPart) element;
	  if (this.part == part) {
		  Application.getInstance().shell.setMaximized(true);
	  }
	 
	} 
}
