package s.d.manager.views;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;

import org.eclipse.e4.core.contexts.ContextInjectionFactory;
import org.eclipse.e4.core.contexts.IEclipseContext;
import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.core.services.nls.ILocaleChangeService;
import org.eclipse.e4.core.services.nls.Translation;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.di.UIEventTopic;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.basic.MTrimmedWindow;
import org.eclipse.e4.ui.model.application.ui.basic.MWindow;
import org.eclipse.e4.ui.workbench.modeling.IWindowCloseHandler;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.events.ShellListener;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Monitor;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;

import s.d.manager.model.Application;
import s.d.manager.model.CustomTray;
import s.d.manager.model.EventConstants;
import s.d.manager.model.Gui;
import s.d.manager.model.Request;
import s.d.manager.model.RequestJobS;
import s.d.manager.model.Settings;
import s.d.manager.model.ups.Battery;
import s.d.manager.model.ups.ControlContact;
import s.d.manager.model.ups.Ups;
import s.d.manager.model.ups.UpsParam;
import s.d.manager.snmp.SnmpShtyl;



public class MainView {

	//private static Logger log = Logger.getLogger(MainView.class.getName());
	private Label upsAlarmLabel;
	private Label upsAlarmLabelValue;
	private Label upsBatteryLabel;
	private Label upsBatteryLabelValue;
	private Label ipAddress;
	private Label ipAddressValue;
	private Label maskLabel;
	private Label maskLabelValue;
	private Label gatewayLabel;
	private Label gatewayLabelValue;
	@Inject Display display;
	@Inject MTrimmedWindow window;
	@Inject MApplication application;
	@Inject Shell shell;
	@Inject @Translation Messages messages;
	@Inject ILocaleChangeService lcs;
	final Settings settings = new Settings();
	CustomTray tray;
	@Inject IEventBroker broker;
	protected SnmpShtyl client;
	@Inject IEclipseContext context;

	//private TableCustom table;
	private Label upsRatedACVoltageLabel;
	private Label upsRatedACVoltageValue;
	private Label upsMaxACCurrentLabel;
	private Label upsMaxACCurrentValue;
	private Label upsNominalBatVoltageLabel;
	private Label upsNominalBatVoltageValue;
	private Label upsRatedFrequencyLabel;
	private Label upsRatedFrequencyValue;
	private Label lineInAlarmLabel;
	private Label lineInAlarmLabelValue;
	private Label ipAddressTrap1;
	private Label ipAddressTrap1Value;
	private Label ipAddressTrap2;
	private Label ipAddressTrap2Value;
	private Label ipAddressTrap3;
	private Label ipAddressTrap3Value;
	private Label ipAddressTrap4;
	private Label ipAddressTrap4Value;
	private int partHeight = 0;
	private List<Label> ccStatusFlagLbls = new ArrayList<Label>();
	private Table phaseParamsTable;
	//private int appHeigh = 680;
	private int appWidth = 500;
	private Gui gui = new Gui();
	private Group UPSPhaseParamsGroup;

	private Group UPSStatusGroup;

	private Group NetworkSettingsgroup;

	private Group TrapSettingsGroup;

	private Group upsPassportGroup;

	private Group upsCCGroup;

	private Label cc1;

	private Label cc2;
	private Label upsBatteryVoltageLabel;
	private Label upsBatteryVoltageLabelValue;
	
	@PostConstruct
	public void createControls(final Composite parent1, final MPart part) {
		final ScrolledComposite sc = new ScrolledComposite(parent1, SWT.V_SCROLL);
		
		final Composite parent = new Composite(sc, SWT.NONE);
		
	    sc.setContent(parent);  
		sc.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,1,1));
		sc.setExpandHorizontal(true);
		
	    parent.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,1,1));
		parent.setLayout(new GridLayout(1, false));
		parent.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));

		createUpsStatusGroup(parent);
		createNetworkSettingsGroup(parent);
		createTrapSettingsGroup(parent);
		createUpsPassportGroup(parent);
		createCCGroup(parent);
		createPhaseTableComposite(parent);
		parent.pack();
		try {
			settings.read();
			ipAddressValue.setText(settings.ipAddressUPS);
			maskLabelValue.setText(settings.mask);
			gatewayLabelValue.setText(settings.gateway);
		} catch (Exception e) {

		}
		initTranslate();
		window.getContext().set(IWindowCloseHandler.class, new IWindowCloseHandler() {
			@Override
			public boolean close(MWindow window) {
				boolean result = MessageDialog.openConfirm(shell, messages.CloseDialogName, messages.CloseDialogText);
				if (result) {
					RequestJobS.getInstance().Stop();
					//RequestJobLog.getInstance().Stop();
					Application.getInstance().tray.deleteItem();
				}
				return result;
				
			}}); 
		
		parent.getShell().addShellListener(new ShellListener() {
			@Override
			public void shellIconified(ShellEvent arg0) {
				if (parent.getShell().isVisible()) {
					parent.getShell().setVisible(false);
				}
			}

			@Override
			public void shellActivated(ShellEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void shellClosed(ShellEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void shellDeactivated(ShellEvent e) {
				// TODO Auto-generated method stub
				
			}

			@Override
			public void shellDeiconified(ShellEvent e) {
				// TODO Auto-generated method stub
				
			}

		});
		tray = new CustomTray(parent, display);
		Application.getInstance().init(shell, display, tray, broker, context, messages);
		ContextInjectionFactory.inject(RequestJobS.getInstance(), context);// ������������ ����� RequestJobS � DI
		//ContextInjectionFactory.inject(DialogPassword.getInstance(), context);
		
		//Application.setConnectionFail(true);
		
		RequestJobS.getInstance().Run();// 
		
		//RequestJobLog.getInstance().Run();
		//Application.dialogIsShown = false;
		Application.getInstance().parent = parent;
		
		if (partHeight>Application.getInstance().parent.getBounds().height) {
			Application.getInstance().shell.setSize(Application.getInstance().shell.getBounds().width, Application.getInstance().shell.getBounds().height+(partHeight-Application.getInstance().parent.getBounds().height));
		}
		
		/*if (partHeight>Application.parent.getBounds().height) {
			Application.shell.getLayout().
		}*/
		
		fillTextValuesFromSettings();
		centerShell(parent);
		
		//shell.pack();
	}
	
	private void createUpsStatusGroup(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		UPSStatusGroup = new Group(composite, SWT.NONE);
		UPSStatusGroup.setText(messages.UpsStatusGroup);
		UPSStatusGroup.setLayout(getGridLayout());
		UPSStatusGroup.setLayoutData(getGridData());
		
		upsAlarmLabel = new Label(UPSStatusGroup, SWT.NONE);
		upsAlarmLabelValue = new Label(UPSStatusGroup, SWT.NONE);
		upsAlarmLabelValue.setText(""); //$NON-NLS-1$
		
		lineInAlarmLabel = new Label(UPSStatusGroup, SWT.NONE);
		lineInAlarmLabel.setText(messages.lineInAlarmLabel);
		lineInAlarmLabelValue = new Label(UPSStatusGroup, SWT.NONE);
		lineInAlarmLabelValue.setText(""); //$NON-NLS-1$
		
		upsBatteryLabel = new Label(UPSStatusGroup, SWT.NONE);
		upsBatteryLabelValue = new Label(UPSStatusGroup, SWT.NONE);
		upsBatteryLabelValue.setText(""); //$NON-NLS-1$
		upsAlarmLabel.setText(messages.AlarmsLabel);
		upsBatteryLabel.setText(messages.BatteryLowFlagLabel);
		
		upsBatteryVoltageLabel = new Label(UPSStatusGroup, SWT.NONE);
		upsBatteryVoltageLabelValue = new Label(UPSStatusGroup, SWT.NONE);
		upsBatteryVoltageLabelValue.setText(""); //$NON-NLS-1$
		
		
		upsBatteryVoltageLabel.setText(messages.BatteryLowFlagLabel);
		
		composite.pack();
		partHeight = partHeight + composite.getBounds().height + ((GridLayout)composite.getLayout()).verticalSpacing;
	}
	
	private void createNetworkSettingsGroup(Composite parent) {
		
		Composite composite = new Composite(parent, SWT.NONE);
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		NetworkSettingsgroup = new Group(composite, SWT.NONE);
		NetworkSettingsgroup.setText(messages.SnmpSettingsGroup);
		NetworkSettingsgroup.setLayout(getGridLayout());
		NetworkSettingsgroup.setLayoutData(getGridData());
		
		ipAddress = new Label(NetworkSettingsgroup, SWT.NONE);
		ipAddressValue = new Label(NetworkSettingsgroup, SWT.NONE);
		maskLabel = new Label(NetworkSettingsgroup, SWT.NONE);
		maskLabelValue = new Label(NetworkSettingsgroup, SWT.NONE);
		gatewayLabel = new Label(NetworkSettingsgroup, SWT.NONE);
		gatewayLabelValue = new Label(NetworkSettingsgroup, SWT.NONE);
		
		ipAddress.setText(messages.ipAddressLabel);
		maskLabel.setText(messages.MaskLabel);
		gatewayLabel.setText(messages.GatewayLabel);
		composite.pack();
		partHeight = partHeight + composite.getBounds().height + ((GridLayout)composite.getLayout()).verticalSpacing;
		
	}
	
	private void createTrapSettingsGroup(Composite parent) {
		
		Composite composite = new Composite(parent, SWT.NONE);
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		TrapSettingsGroup = new Group(composite, SWT.NONE);
		TrapSettingsGroup.setText(messages.TrapSettingsGroup);
		TrapSettingsGroup.setLayoutData(getGridData());
		TrapSettingsGroup.setLayout(getGridLayout());
		
		ipAddressTrap1 = new Label(TrapSettingsGroup, SWT.NONE);
		ipAddressTrap1.setText(messages.ipAddressTrap1);
		ipAddressTrap1Value = new Label(TrapSettingsGroup, SWT.NONE);
		
		ipAddressTrap2 = new Label(TrapSettingsGroup, SWT.NONE);
		ipAddressTrap2.setText(messages.ipAddressTrap2);
		ipAddressTrap2Value = new Label(TrapSettingsGroup, SWT.NONE);
		
		ipAddressTrap3 = new Label(TrapSettingsGroup, SWT.NONE);
		ipAddressTrap3.setText(messages.ipAddressTrap3);
		ipAddressTrap3Value = new Label(TrapSettingsGroup, SWT.NONE);
		
		ipAddressTrap4 = new Label(TrapSettingsGroup, SWT.NONE);
		ipAddressTrap4.setText(messages.ipAddressTrap4);
		ipAddressTrap4Value = new Label(TrapSettingsGroup, SWT.NONE);
		composite.pack();
		partHeight = partHeight + composite.getBounds().height +  ((GridLayout)composite.getLayout()).verticalSpacing;
	
	}
	
	private void createCCGroup(Composite parent) {
		
		Composite composite = new Composite(parent, SWT.NONE);
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		upsCCGroup = new Group(composite, SWT.NONE);
		upsCCGroup.setText(messages.ControlContactsGroupName);
		upsCCGroup.setLayoutData(getGridData());
		upsCCGroup.setLayout(getGridLayout());
		
		cc1 = new Label(upsCCGroup, SWT.NONE);
		cc1.setText(messages.ControlContact1Lbl);
		
		Label cc1StatusFlag = new Label(upsCCGroup, SWT.NONE);
		
		cc2 = new Label(upsCCGroup, SWT.NONE);
		cc2.setText(messages.ControlContact2Lbl);
		Label cc2StatusFlag = new Label(upsCCGroup, SWT.NONE);
		
		ccStatusFlagLbls .add(cc1StatusFlag);
		ccStatusFlagLbls.add(cc2StatusFlag);
		composite.pack();
		partHeight = partHeight + composite.getBounds().height +  ((GridLayout)composite.getLayout()).verticalSpacing;
		
	}
	private void createUpsPassportGroup(Composite parent) {
		
		Composite composite = new Composite(parent, SWT.NONE);
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		upsPassportGroup = new Group(composite, SWT.NONE);
		upsPassportGroup.setText(messages.upsPassportGroup);
		upsPassportGroup.setLayoutData(getGridData());
		upsPassportGroup.setLayout(getGridLayout());
		
		
		upsRatedACVoltageLabel = new Label(upsPassportGroup, SWT.NONE);
		upsRatedACVoltageLabel.setText(messages.upsRatedACVoltageLabel);
		upsRatedACVoltageValue = new Label(upsPassportGroup, SWT.NONE);
		upsMaxACCurrentLabel = new Label(upsPassportGroup, SWT.NONE);
		upsMaxACCurrentLabel.setText(messages.upsMaxACCurrentLabel);
		upsMaxACCurrentValue = new Label(upsPassportGroup, SWT.NONE);
		upsNominalBatVoltageLabel = new Label(upsPassportGroup, SWT.NONE);
		upsNominalBatVoltageLabel.setText(messages.upsNominalBatVoltageLabel);
		upsNominalBatVoltageValue = new Label(upsPassportGroup, SWT.NONE);
		upsRatedFrequencyLabel = new Label(upsPassportGroup, SWT.NONE);
		upsRatedFrequencyLabel.setText(messages.upsRatedFrequencyLabel);
		upsRatedFrequencyValue = new Label(upsPassportGroup, SWT.NONE);
		composite.pack();
		partHeight = partHeight + composite.getBounds().height +  ((GridLayout)composite.getLayout()).verticalSpacing;
		
	}
	
	private void createPhaseTableComposite(Composite parent) {
		
		Composite composite = new Composite(parent, SWT.NONE);
		//Composite composite = new ScrolledComposite(shell, SWT.V_SCROLL);
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		UPSPhaseParamsGroup = new Group(composite, SWT.NONE);
		UPSPhaseParamsGroup.setText(messages.UpsStatusGroup);
		
		UPSPhaseParamsGroup.setLayout(new GridLayout(1, false));
		UPSPhaseParamsGroup.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
	
		gui.setComposite(UPSPhaseParamsGroup);
		phaseParamsTable = gui.createTable(messages.PhaseBorderLabel, messages.PhaseBorderUinput, 
				messages.PhaseBorderFinput, messages.PhaseBorderUoutput, messages.PhaseBorderCurrentLoad);
		phaseParamsTable.setLayout(new GridLayout(1, false));
		
		GridData gd = new GridData(SWT.FILL, SWT.FILL, true, true);
		gd.minimumWidth = appWidth-90;
		phaseParamsTable.setLayoutData(gd);
		//phaseParamsTable.pack();
		composite.pack();
		partHeight = partHeight + composite.getBounds().height + ((GridLayout)composite.getLayout()).verticalSpacing;
		//partHeight = partHeight + composite.getBounds().height;
		
	}
	
	@PreDestroy
	public void dispose(){
		//ct.DeleteTray();
		RequestJobS.getInstance().Stop();
		Application.getInstance().tray.deleteItem();
	}
	
	public Label getUpsAlarmLabel(){
	    return upsAlarmLabelValue;
	}
	
	public Label getLineInAlarmLabel(){
	    return lineInAlarmLabelValue;
	}
	
	public Label getUpsBatteryLabel(){
		return upsBatteryLabelValue;
	}
	
	public void setLabelValue(final Label label, final String value){
		
		try {
			Display.getDefault().asyncExec(new Runnable() {
		          public void run() {
		        	  label.setText(value);
		        	  label.pack();
		          }
			});
		} catch (Exception e) {
			 //log.log(Level.SEVERE, "Exception: ", e);
		}
		
	}
		
	public void setLabelColor(final Label label, final Integer color){
		try {
			Display.getDefault().asyncExec(new Runnable() {
		          public void run() {
		        	  label.setForeground(Display.getDefault().getSystemColor(color));
		        	  label.pack();
		          }
			});
		} catch (Exception e) {
			 //log.log(Level.SEVERE, "Exception: ", e);
		}
			
	}
	
	@Focus
	private void setFocus() {
		try {
			fillTextValuesFromSettings();
			//UPSPhaseParamsGroup.pack();
		} catch (Exception e) {
			
		}
	}
	
	public void fillTextValuesFromSettings() {
		try{
			settings.read();
			ipAddress.setFocus();
			settings.read();
			ipAddressValue.setText(settings.ipAddressUPS);
			ipAddressValue.pack();
			maskLabelValue.setText(settings.mask);
			maskLabelValue.pack();
			gatewayLabelValue.setText(settings.gateway);
			gatewayLabelValue.pack();
			upsRatedACVoltageValue.setText(settings.upsRatedACVoltage);
			upsRatedACVoltageValue.pack();
			upsMaxACCurrentValue.setText(settings.upsMaxACCurrent);
			upsMaxACCurrentValue.pack();
			upsNominalBatVoltageValue.setText(settings.upsNominalBatVoltage);
			upsNominalBatVoltageValue.pack();
			upsRatedFrequencyValue.setText(settings.upsRatedFrequency);
			upsRatedFrequencyValue.pack();
			ipAddressTrap1Value.setText(settings.ipAddressTrap1);
			ipAddressTrap1Value.pack();
			ipAddressTrap2Value.setText(settings.ipAddressTrap2);
			ipAddressTrap2Value.pack();
			ipAddressTrap3Value.setText(settings.ipAddressTrap3);
			ipAddressTrap3Value.pack();
			ipAddressTrap4Value.setText(settings.ipAddressTrap4);
			ipAddressTrap4Value.pack();
			
		}catch(Exception e){
			
		}
	}
	
	public GridLayout getGridLayout() {
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		//gridLayout.marginWidth = 2;
		return gridLayout;
	}
	
	public GridData getGridData() {
		GridData gridData = new GridData(SWT.FILL, SWT.FILL, true, true);
	    gridData.horizontalSpan= 2;
	    gridData.minimumWidth = appWidth-50;
		return gridData;
	    
	}
	
	public void centerShell(Composite parent) {
		Monitor primary = Display.getDefault().getPrimaryMonitor();
		Application.getInstance().shell.setSize(appWidth, partHeight + 170);
		//Application.shell.setSize(appWidth, partHeight +1000);
	    Rectangle bounds = primary.getBounds();
	    Rectangle rect = Application.getInstance().shell.getBounds();
	    int x = bounds.x + (bounds.width - rect.width) / 2;
	    int y = bounds.y + (bounds.height - rect.height) / 2;
	    
	    Application.getInstance().shell.setLocation(x, y);
	    Application.getInstance().shell.open();
	}
	
	@Inject @Optional
	public void HandlerGetTrapAndPassportParam(@UIEventTopic(EventConstants.GET_TRAP_AND_PASSPORT_PARAMS) final Request request) {
		settings.loadValuesFromUps(request.getUps());
		fillTextValuesFromSettings();
	}
	
	@Inject @Optional
	public void HandlerRefreshCCGroup(@UIEventTopic(EventConstants.REFRESH_CC_GROUP) final List<ControlContact> cContacts) {
		if (cContacts!=null) {
			for (int i = 0; i<cContacts.size(); i++) {
				if (cContacts.get(i).getStatusFlag() != null) {
					ccStatusFlagLbls.get(i).setText(cContacts.get(i).getStatusFlagAsString());
					ccStatusFlagLbls.get(i).pack();
				} else {
					ccStatusFlagLbls.get(i).setText("n/a");
					ccStatusFlagLbls.get(i).pack();
				}
			}
		} else {
			for (Label lbl :ccStatusFlagLbls) {
				lbl.setText("n/a"); 
				lbl.pack();
			}
		}
	}
	
	@Inject @Optional
	public void HandlerRefreshFlagsGroup(@UIEventTopic(EventConstants.REFRESH_FLAGS_GROUP) final Ups ups) {
		if (ups.getUpsParams() != null) {
			if (ups.getUpsParams().getUpsConnectedFlag() == 0) {
				//setUpsAlarmFlag(upsParams.getUpsAlarmFlag());
				setUpsConnectedFlag(ups.getUpsParams().getUpsConnectedFlag());
				setLineInAlarmFlag(null);
				setBatteryFlag(null);
				setBatteryEstimateCharge(null);
			} else {
				setUpsAlarmFlag(ups.getUpsParams());
				setLineInAlarmFlag(ups.getUpsParams());
				setBatteryFlag(ups.getUpsParams());
				setBatteryEstimateCharge(ups.getBattery());
			}
		} else {
			setUpsAlarmFlag(null);
			setLineInAlarmFlag(null);
			setBatteryFlag(null);
			setBatteryEstimateCharge(null);
		}
	}
	
	@Inject @Optional
	public void HandlerRefreshPhaseTable(@UIEventTopic(EventConstants.REFRESH_PHASE_GROUP) final Ups ups) {
		gui.clearTable(phaseParamsTable);
		if (ups.getUpsParams() != null) {
			if (ups.getUpsParams().getUpsConnectedFlag() == 0 ) {
				gui.fillPhaseParamsTable(null, phaseParamsTable);
				return;
			}
		} 
		gui.fillPhaseParamsTable(ups.getPhaseParams(), phaseParamsTable);
	}
	
	private void setUpsAlarmFlag(UpsParam upsParams) {
		//if (upsParams.getUpsAlarmFlag() == null) {
		
		if  (upsParams == null) {
			setLabelColor(getUpsAlarmLabel(), SWT.COLOR_RED);
			setLabelValue(getUpsAlarmLabel(), messages.UpsConnectionLost);
			return;
		}
		if (upsParams.getUpsAlarmFlag() == 1) {
			setLabelColor(getUpsAlarmLabel(), SWT.COLOR_RED);
			setLabelValue(getUpsAlarmLabel(), messages.AlarmsIsPresent);
			//return;
		}
		if (upsParams.getUpsAlarmFlag() == 0) {
			setLabelColor(getUpsAlarmLabel(), SWT.COLOR_DARK_GREEN);
			setLabelValue(getUpsAlarmLabel(), messages.AlarmsNotPresent);
			//return;
		}
		if (upsParams.getUpsOverloadFlag() != null) {
			if (upsParams.getUpsOverloadFlag() == 1) {
				setLabelColor(getUpsAlarmLabel(), SWT.COLOR_RED);
				setLabelValue(getUpsAlarmLabel(), messages.overload);
				broker.send(EventConstants.TOOLITEM_ALARM, messages.overload);
			}/* else {
				setLabelColor(getUpsAlarmLabel(), SWT.COLOR_DARK_GREEN);
				setLabelValue(getUpsAlarmLabel(), messages.AlarmLineInPresent);
			}*/
		}
		if (upsParams.getUpsEmergencyFlag() != null) {
			if (upsParams.getUpsEmergencyFlag() == 1) {
				setLabelColor(getUpsAlarmLabel(), SWT.COLOR_RED);
				setLabelValue(getUpsAlarmLabel(), messages.ePo);
				broker.send(EventConstants.TOOLITEM_ALARM, messages.ePo);
				
			}/* else {
				setLabelColor(getUpsAlarmLabel(), SWT.COLOR_DARK_GREEN);
				setLabelValue(getUpsAlarmLabel(), messages.AlarmLineInPresent);
			}*/
		}
		
	}
	
	private void setUpsConnectedFlag(Integer flag) {
		if (flag == 0) {
			setLabelColor(getUpsAlarmLabel(), SWT.COLOR_RED);
			setLabelValue(getUpsAlarmLabel(), messages.AlarmUpsNotConnected);
			return;
		}
	}
	
	private void setLineInAlarmFlag(UpsParam upsParams) {
		if (upsParams != null) {
			if (upsParams.getUpsInVoltageFlag() == null) {
				setLabelColor(getLineInAlarmLabel(), SWT.COLOR_RED);
				setLabelValue(getLineInAlarmLabel(), "n/a");
				return;
			}
			if (upsParams.getUpsInVoltageFlag() == 1) {
				setLabelColor(getLineInAlarmLabel(), SWT.COLOR_RED);
				setLabelValue(getLineInAlarmLabel(), messages.AlarmLineInNotPresent);
				return;
			}
			//TODO   ,     RequestJob
			if (upsParams.getUpsInVoltageFlag() == 0) {
				
				if (upsParams.getUpsBypassStatusFlag() == 1) {
					setLabelColor(getLineInAlarmLabel(), SWT.COLOR_RED);
					setLabelValue(getLineInAlarmLabel(), messages.SchemeModeBypass);
					//broker.send(EventConstants.TOOLITEM_ALARM, messages.SchemeModeBypass);
				} else {
					setLabelColor(getLineInAlarmLabel(), SWT.COLOR_DARK_GREEN);
					setLabelValue(getLineInAlarmLabel(), messages.AlarmLineInPresent);
				}
				return;
			}
		} else {
			setLabelColor(getLineInAlarmLabel(), SWT.COLOR_RED);
			setLabelValue(getLineInAlarmLabel(), "n/a");
		}
	}
	
	public void setBatteryFlag(UpsParam upsParams) {		
		if (upsParams != null) {
			Integer alarmFlag = upsParams.getUpsBatteryAlarmFlag();
			Integer batteryLowFlag = upsParams.getUpsBatteryLowFlag();			
			if (alarmFlag == null | batteryLowFlag == null) {
				setLabelColor(getUpsBatteryLabel(), SWT.COLOR_RED);
				setLabelValue(getUpsBatteryLabel(), "n/a");
				return;
			}
			
			if (alarmFlag == 2 & batteryLowFlag == 1) {
				setBatteryProblem(1);
				return;
			}
			
			if (alarmFlag == 2 & batteryLowFlag == 0) {
				setBatteryProblem(2);
				return;
			}
			
			if (alarmFlag == 1 & batteryLowFlag == 0) {
				setBatteryProblem(1);
				return;
			}
			if (alarmFlag == 0 & batteryLowFlag == 1) {
				setBatteryLow(1);
				return;
			}
			if (alarmFlag == 0 & batteryLowFlag == 0) {
				setBatteryLow(0);
				return;
			}
			if (alarmFlag == 1 & batteryLowFlag == 1) {
				setBatteryLow(1);
				return;
			}
		} else {
			setLabelColor(getUpsBatteryLabel(), SWT.COLOR_RED);
			setLabelValue(getUpsBatteryLabel(), "n/a");
		}
		
	}
	
	public void setBatteryEstimateCharge(Battery battery) {		
		if (battery != null) {
			if (battery.getEstimateCharge() != null) {
				setLabelColor(upsBatteryVoltageLabelValue, SWT.COLOR_DARK_GREEN);
				setLabelValue(upsBatteryVoltageLabelValue, String.valueOf(battery.getEstimateCharge() + " %"));
			} else {
				setLabelColor(upsBatteryVoltageLabelValue, SWT.COLOR_RED);
				setLabelValue(upsBatteryVoltageLabelValue, "n/a");
			}
		} else {
			setLabelColor(upsBatteryVoltageLabelValue, SWT.COLOR_RED);
			setLabelValue(upsBatteryVoltageLabelValue, "n/a");
		}
		
	}
	
	private void setBatteryProblem(Integer batteryProblem){
		switch (batteryProblem){
		case -1: setLabelColor(getUpsBatteryLabel(), SWT.COLOR_RED);
				 setLabelValue(getUpsBatteryLabel(), "n/a");
				 break;
		case 1:	 setLabelColor(getUpsBatteryLabel(), SWT.COLOR_RED);
				 setLabelValue(getUpsBatteryLabel(), messages.BatteryStateProblem);
				 break;
		case 0:  setLabelColor(getUpsBatteryLabel(), SWT.COLOR_DARK_GREEN);
				 setLabelValue(getUpsBatteryLabel(), messages.BatteryStateOk);
				 break;
		case 2:  setLabelColor(getUpsBatteryLabel(), SWT.COLOR_RED);
		 		 setLabelValue(getUpsBatteryLabel(), messages.BatteryStateDepleted);
		 		 break;
		}
	}
	
	private void setBatteryLow(Integer batteryLow){
		switch (batteryLow){
		
		case -1: setLabelColor(getUpsBatteryLabel(), SWT.COLOR_RED);
				 setLabelValue(getUpsBatteryLabel(), "n/a");
				 break;
		case 1:	 setLabelColor(getUpsBatteryLabel(), SWT.COLOR_RED);
				 setLabelValue(getUpsBatteryLabel(), messages.BatteryStateLow);
				 break;
		case 0:  setLabelColor(getUpsBatteryLabel(), SWT.COLOR_DARK_GREEN);
				 setLabelValue(getUpsBatteryLabel(), messages.BatteryStateOk);
				 break;
		}	
	}
	
	@Inject
	  public void translate(@Translation Messages messages) {		
		try {			
			UPSStatusGroup.setText(messages.UpsStatusGroup);
			lineInAlarmLabel.setText(messages.lineInAlarmLabel);
			upsAlarmLabel.setText(messages.AlarmsLabel);
			upsBatteryLabel.setText(messages.BatteryLowFlagLabel);
			upsBatteryLabel.setText(messages.BatteryLowFlagLabel);
			upsBatteryVoltageLabel.setText(messages.BatteryCharge);
			
			NetworkSettingsgroup.setText(messages.SnmpSettingsGroup);
			ipAddress.setText(messages.ipAddressLabel);
			maskLabel.setText(messages.MaskLabel);
			gatewayLabel.setText(messages.GatewayLabel);

			TrapSettingsGroup.setText(messages.TrapSettingsGroup);
			ipAddressTrap1.setText(messages.ipAddressTrap1);
			ipAddressTrap2.setText(messages.ipAddressTrap2);
			ipAddressTrap3.setText(messages.ipAddressTrap3);
			ipAddressTrap4.setText(messages.ipAddressTrap4);

			upsCCGroup.setText(messages.ControlContactsGroupName);
			cc1.setText(messages.ControlContact1Lbl);
			cc2.setText(messages.ControlContact2Lbl);

			upsPassportGroup.setText(messages.upsPassportGroup);
			upsRatedACVoltageLabel.setText(messages.upsRatedACVoltageLabel);
			upsMaxACCurrentLabel.setText(messages.upsMaxACCurrentLabel);
			upsNominalBatVoltageLabel.setText(messages.upsNominalBatVoltageLabel);
			upsRatedFrequencyLabel.setText(messages.upsRatedFrequencyLabel);

			UPSPhaseParamsGroup.setText(messages.UpsStatusGroup);
			
			phaseParamsTable.getColumn(0).setText(messages.PhaseBorderLabel);
			phaseParamsTable.getColumn(1).setText(messages.PhaseBorderUinput);
			phaseParamsTable.getColumn(2).setText(messages.PhaseBorderFinput);
			phaseParamsTable.getColumn(3).setText(messages.PhaseBorderUoutput);
			phaseParamsTable.getColumn(4).setText(messages.PhaseBorderCurrentLoad);
			
		} catch (Exception e){
			
		}
	}
	private void initTranslate() {
		if ((settings.systemLanguage).equals("0")) {
    		lcs.changeApplicationLocale("en");	    		 
        } else if ((settings.systemLanguage).equals("1")) {
        	lcs.changeApplicationLocale("ru");	        	
        }			
		//translate(messages);
		Application.getInstance().messages = messages;
	}
}
