package s.d.manager.views;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.core.di.extensions.EventTopic;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import s.d.manager.model.Colors;
import s.d.manager.model.EventConstants;
import s.d.manager.model.Request;
import s.d.manager.model.Settings;
import s.d.manager.scheme.Scheme;


public class SchemeView {
	@Inject
	IEventBroker broker;
	private Request request;
	private Canvas canvas;
	final Settings settings = new Settings();
	private Rectangle clientArea;
	
	@PostConstruct
	public void createControls(final Composite parent) {
		canvas = new Canvas(parent, SWT.DOUBLE_BUFFERED);
		setCanvas(canvas);
		clientArea = parent.getBounds();
		canvas.setBackground(Colors.DARK_GREEN);
		canvas.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
				settings.read();
				clientArea = parent.getBounds();
				Scheme scheme = new Scheme(e.gc, clientArea);
				try {
					//scheme.Create(Integer.parseInt(settings.upsPhaseCount));	
					scheme.Create(getRequest().getUps().getPhaseParams().size());
					//scheme.Create(3);
				} catch (Exception e1) {
					scheme.Create(3);
				}
				scheme.redraw(getRequest());
				e.gc.dispose();
				try {
					scheme.dispose();
				} catch (Exception e1){
					
				}
				clientArea = null;
			}
		});
		
	}
	
	@PreDestroy
	public void dispose(){
		canvas.dispose();
	}
	
	public void setCanvas(Canvas canvas) {
		this.canvas = canvas;
	}

	public Canvas getCanvas() {
		return canvas;
	}

	public void redrawCanvas() {
		Display.getDefault().asyncExec(new Runnable() {
			public void run() {
				getCanvas().redraw();
			}
		});
	}

	public void setRequest(Request request) {
		this.request = request;
	}

	public Request getRequest() {
		return request;
	}

	@Inject
	@Optional
	public void HandlerSetPhaseParam(@EventTopic(EventConstants.SCHEME_VIEW) Request request) {
		setRequest(request);
		if (request == null){
			//System.out.println(" ");
		}
		redrawCanvas();
	}
	
}
