package s.d.manager.views;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.core.di.extensions.EventTopic;
import org.eclipse.e4.core.services.nls.ILocaleChangeService;
import org.eclipse.e4.core.services.nls.Translation;
import org.eclipse.e4.ui.di.Focus;
import org.eclipse.e4.ui.di.UIEventTopic;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.basic.MTrimmedWindow;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import s.d.manager.dialogs.DialogBatteryTest;
import s.d.manager.dialogs.DialogOpenAccess;
import s.d.manager.dialogs.DialogPassword;
import s.d.manager.dialogs.DialogSelectConnection;
import s.d.manager.dialogs.DialogServiceParams;
import s.d.manager.dialogs.DialogControlContactsLinux;
import s.d.manager.model.Application;
import s.d.manager.model.EventConstants;
import s.d.manager.model.Request;
import s.d.manager.model.RequestJobS;
import s.d.manager.model.Settings;
import s.d.manager.model.SoundClass;
import s.d.manager.model.ups.NetworkSettings;
import s.d.manager.model.ups.Ups;
import s.d.manager.model.ups.UpsParam;

public class SettingsView {
	
	private Label ipAddressUPS;
	private Text ipAddressUPSText;
	private Label mask;
	private Text maskText;
	private Label gateway;
	private Text gatewayText;
	private Label communityWrite;
	private Text communityWriteText;
	private Label port;
	private Text portText;
	private Label communityRead;
	private Text communityReadText;
	@Inject Display display;
	@Inject MTrimmedWindow window;
	@Inject MApplication application;
	@Inject Shell shell;
	final Settings settings = new Settings();
	@Inject EPartService ps;
	private Button ApplyParamsButton1;
	private Button SetToDefaultValuesButton1;
	private Label onBatteryLow;
	private Label onInpitLineFail;
	private Combo alarmEventBatteryLow;
	private Combo alarmEventInputLineFail;
	private Label ipAddressTrap1;
	private Text ipAddressTrap1Text;
	private Label ipAddressTrap2;
	private Text ipAddressTrap2Text;
	private Label ipAddressTrap3;
	private Text ipAddressTrap3Text;
	private Label ipAddressTrap4;
	private Text ipAddressTrap4Text;
	private Request request;
	private List<Text> ipAddressTrapTextList = new ArrayList<Text>();
	private List<Text> networkSettingsTextList = new ArrayList<Text>();
	private Label trapLanguage;
	private Combo trapLanguageCombo;
	private int partHeight = 0;
	private Button relayButton;
	private Button startTestButton;
	private Button changePassword;
	private Button serviceInformation;
	private Label ipAddressWanLbl;
	private Text ipAddressWanText;
	
	@Inject @Translation Messages messages;
	
	@Inject ILocaleChangeService lcs;
	
	private Group SystemSettingsgroup;
	private Group connectionSettingsgroup;
	private Group UpsSettingsGroup;
	private Group TrapSettingsGroup;
	private Label systemLanguage;
	private Combo systemLanguageCombo;
	private Label soundSignalization;
	private Combo soundSignalizationCombo;
	
	@PostConstruct 
	public void createControls(final Composite parent1) {
		
		final ScrolledComposite sc = new ScrolledComposite(parent1, SWT.V_SCROLL);
	   
		final Composite parent = new Composite(sc, SWT.NONE);
		
	    sc.setContent(parent);
	    sc.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,1,1));
	    sc.setExpandHorizontal(true);
	    
	    parent.setLayout(new GridLayout(1, false));
		parent.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		createSystemSettingsGroup(parent);
		createConnectionSettingsGroup(parent);
		createUpsSettingsGroup(parent);
		createTrapSettingsGroup(parent);
		createButtonsGroup(parent);
		fillTextValuesFromSettings();
		setButtons(false);
		parent.pack();
		//parent1.pack();
		//sc.pack();
		/*if (partHeight>Application.parent.getBounds().height) {
			Application.shell.setSize(Application.shell.getBounds().width, Application.shell.getBounds().height+(partHeight-Application.parent.getBounds().height));
		}*/
	}
	
	private void createSystemSettingsGroup(Composite parent) {
		
		//Composite composite1 = createComposite(getGridDataMain(), parent);
		
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(parent.getLayout());
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		SystemSettingsgroup = new Group(composite, SWT.NONE);
		SystemSettingsgroup.setText(messages.SystemSettingsGroup);
	    //���������� ������ ������ Group
		SystemSettingsgroup.setLayout(getGridLayout());
		SystemSettingsgroup.setLayoutData(getGridData());
		
		onBatteryLow = new Label(SystemSettingsgroup, SWT.NONE);
		onBatteryLow.setText(messages.OnBatteryLowLabel);
		onBatteryLow.setLayoutData(getGridDataText());
		alarmEventBatteryLow = new Combo(SystemSettingsgroup, SWT.NONE);
		alarmEventBatteryLow.setItems(new String[] { messages.AlarmEventComboShutdownPC, messages.AlarmEventComboHybernate, messages.AlarmEventComboNone}); 
		alarmEventBatteryLow.setLayout(getGridLayout());/////
		alarmEventBatteryLow.setLayoutData(getGridDataText());
		
		//onInpitLineFail = onBatteryLow = new Label(SystemSettingsgroup, SWT.NONE);
		onInpitLineFail = new Label(SystemSettingsgroup, SWT.NONE);
		onInpitLineFail.setText(messages.OnInputLineFailLabel);
		
		alarmEventInputLineFail = new Combo(SystemSettingsgroup, SWT.NONE);
		alarmEventInputLineFail.setItems(new String[] { messages.AlarmEventComboShutdownPC, messages.AlarmEventComboHybernate, messages.AlarmEventComboNone}); 
		alarmEventInputLineFail.setLayout(getGridLayout());/////
		alarmEventInputLineFail.setLayoutData(getGridDataText());
		
		systemLanguage = new Label(SystemSettingsgroup, SWT.NONE);
		systemLanguage.setText(messages.systemLanguageCombo);
		systemLanguageCombo = new Combo(SystemSettingsgroup, SWT.NONE);
		systemLanguageCombo.setLayoutData(getGridDataText());
		systemLanguageCombo.setItems(new String[] { "EN","RU"}); 
		systemLanguageCombo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
		    	if (systemLanguageCombo.getText().equals("EN")) {
		    		 lcs.changeApplicationLocale("en");
		        } else if (systemLanguageCombo.getText().equals("RU")) {
		        	lcs.changeApplicationLocale("ru");		        	
		        }
				settings.writeSystemLanguageValue(systemLanguageCombo);								
				translate(messages);
				fillTextValuesFromSettings();
				Application.getInstance().messages = messages;
		      }
		});
		
		soundSignalization = new Label(SystemSettingsgroup, SWT.NONE);
		soundSignalization.setText(messages.soundSignalization);
		soundSignalizationCombo = new Combo(SystemSettingsgroup, SWT.NONE);
		soundSignalizationCombo.setLayoutData(getGridDataText());
		soundSignalizationCombo.setItems(new String[] { messages.ComboSoundSignalizationDisabled, messages.ComboSoundSignalizationExternalSpeakers}); 
		soundSignalizationCombo.addSelectionListener(new SelectionAdapter() {
		public void widgetSelected(SelectionEvent e) {
		    	settings.writeSoundSignalizationCombo(systemLanguageCombo);		
		    	fillTextValuesFromSettings();
		      }
		});
		
		composite.pack();
		partHeight = partHeight + composite.getBounds().height;
		
	}
	
	private void createConnectionSettingsGroup(Composite parent) {
		
		//Composite composite = createComposite(getGridDataMain(), parent);
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(parent.getLayout());
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		connectionSettingsgroup = new Group(composite, SWT.NONE);
		connectionSettingsgroup.setText(messages.SnmpAccessGroup);
		connectionSettingsgroup.setLayoutData(getGridData());
		connectionSettingsgroup.setLayout(getGridLayout());
		
		ipAddressWanLbl = new Label(connectionSettingsgroup, SWT.NONE);
		ipAddressWanLbl.setText(messages.AddressLabel);
		ipAddressWanText = new Text(connectionSettingsgroup, SWT.BORDER);
		ipAddressWanText.setLayoutData(getGridDataText());
		
		//networkSettingsTextList.add(ipAddressWanText);
		
		port = new Label(connectionSettingsgroup, SWT.NONE);
		portText = new Text(connectionSettingsgroup, SWT.BORDER);
		portText.setLayoutData(getGridDataText());
		portText.addListener (SWT.Verify, new Listener () {
            public void handleEvent (Event e) {
                String string = e.text;
                char [] chars = new char [string.length ()];
                string.getChars (0, chars.length, chars, 0);
                for (int i=0; i<chars.length; i++) {
                    if (!('0' <= chars [i] && chars [i] <= '9')) {
                            e.doit = false;
                            return;
                    }
                }
            }
		});
		//portText.setEnabled(false);
		communityRead = new Label(connectionSettingsgroup, SWT.NONE);
		communityReadText = new Text(connectionSettingsgroup, SWT.BORDER);
		communityReadText.setLayoutData(getGridDataText());
		
		communityWrite = new Label(connectionSettingsgroup, SWT.NONE);
		communityWrite.setText(messages.CommunityWriteLabel);
		communityWriteText = new Text(connectionSettingsgroup, SWT.BORDER);
		communityWriteText.setLayoutData(getGridDataText());
	
		changePassword = new Button(connectionSettingsgroup, SWT.NONE);
		changePassword.setText(messages.ChangePasswordBtn);
		port.setText(messages.PortLabel);
		communityRead.setText(messages.CommunityReadLabel);
		
		/*connectFromOutsideBtn = new Button(connectionSettingsgroup, SWT.CHECK);
		connectFromOutsideBtn.setText(Messages.ChkBoxConnectionFromAnotherSubnet);
		connectFromOutsideBtn.setToolTipText(" "+Messages.ChkBoxConnectionFromAnotherSubnetToolTip);
		connectFromOutsideBtn.addSelectionListener(new SelectionAdapter() {
			@Override
		    public void widgetSelected(SelectionEvent e) {
		        Button button = (Button) e.widget;
		        if (button.getSelection())
		            connectFromOutside = true;
		        else
		        	connectFromOutside = false;
		    }
		});*/
		
		changePassword.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				new DialogPassword();
				//ContextInjectionFactory.inject(dialog, Application.context);
			}
		});
		composite.pack();
		partHeight = partHeight + composite.getBounds().height;
	}
	
	private void createUpsSettingsGroup(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		UpsSettingsGroup = new Group(composite, SWT.NONE);
		UpsSettingsGroup.setText(messages.SnmpSettingsGroup);
		UpsSettingsGroup.setLayoutData(getGridData());
		UpsSettingsGroup.setLayout(getGridLayout());
		
		ipAddressUPS = new Label(UpsSettingsGroup, SWT.NONE);
		ipAddressUPS.setText(messages.ipAddressLabel);
		ipAddressUPSText = new Text(UpsSettingsGroup, SWT.BORDER);
		ipAddressUPSText.setLayoutData(getGridDataText());
		
		mask = new Label(UpsSettingsGroup, SWT.NONE);
		maskText = new Text(UpsSettingsGroup, SWT.BORDER);
		maskText.setLayoutData(getGridDataText());
		gateway = new Label(UpsSettingsGroup, SWT.NONE);
		gatewayText = new Text(UpsSettingsGroup, SWT.BORDER);
		gatewayText.setLayoutData(getGridDataText());
		mask.setText(messages.MaskLabel);
		gateway.setText(messages.GatewayLabel);
		composite.pack();
		partHeight = partHeight + composite.getBounds().height;
	}
	
	private void createTrapSettingsGroup(Composite parent) {
		Composite composite1 = new Composite(parent, SWT.NONE);
		//composite1.setLayout(new GridLayout(1, false));
		composite1.setLayout(parent.getLayout());
		composite1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		TrapSettingsGroup = new Group(composite1, SWT.NONE);
		TrapSettingsGroup.setText(messages.TrapSettingsGroup);
		TrapSettingsGroup.setLayout(new GridLayout(2, false));
		TrapSettingsGroup.setLayoutData(getGridData());
		
		ipAddressTrap1 = new Label(TrapSettingsGroup, SWT.NONE);
		ipAddressTrap1.setText(messages.ipAddressTrap1);
		ipAddressTrap1.pack();
		
		ipAddressTrap1Text = new Text(TrapSettingsGroup, SWT.BORDER);
		ipAddressTrap1Text.setLayoutData(getGridDataText());
		ipAddressTrap1Text.pack();
		
		ipAddressTrap2 = new Label(TrapSettingsGroup, SWT.NONE);
		ipAddressTrap2.setText(messages.ipAddressTrap2);
		ipAddressTrap2Text = new Text(TrapSettingsGroup, SWT.BORDER);
		ipAddressTrap2Text.setLayoutData(getGridDataText());
		
		ipAddressTrap3 = new Label(TrapSettingsGroup, SWT.NONE);
		ipAddressTrap3.setText(messages.ipAddressTrap3);
		ipAddressTrap3Text = new Text(TrapSettingsGroup, SWT.BORDER);
		ipAddressTrap3Text.setLayoutData(getGridDataText());
		
		ipAddressTrap4 = new Label(TrapSettingsGroup, SWT.NONE);
		ipAddressTrap4.setText(messages.ipAddressTrap4);
		ipAddressTrap4Text = new Text(TrapSettingsGroup, SWT.BORDER);
		ipAddressTrap4Text.setLayoutData(getGridDataText());
		
		Composite composite = new Composite(TrapSettingsGroup, SWT.NONE);
		composite.setLayoutData(getGridData());
		composite.setLayout(new GridLayout(2, false));
		trapLanguage = new Label(composite, SWT.NONE);
		trapLanguage.setText(messages.trapLanguage);
		trapLanguageCombo = new Combo(composite, SWT.NONE);
		trapLanguageCombo.setItems(new String[] { "EN","RU"}); 
		
		ipAddressTrapTextList.add(ipAddressTrap1Text);
		ipAddressTrapTextList.add(ipAddressTrap2Text);
		ipAddressTrapTextList.add(ipAddressTrap3Text);
		ipAddressTrapTextList.add(ipAddressTrap4Text);
		
		networkSettingsTextList.add(ipAddressUPSText);
		networkSettingsTextList.add(maskText);
		networkSettingsTextList.add(gatewayText);
		composite1.pack();
		composite.pack();
		partHeight = partHeight + composite1.getBounds().height+composite.getBounds().height;
	}
	
	private void createButtonsGroup(Composite parent) {
		
		Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayout(new GridLayout(3, false));
		composite.setLayoutData(new GridData(SWT.RIGHT, SWT.BOTTOM, true, true));
	
		ApplyParamsButton1 = new Button(composite, SWT.PUSH);
		ApplyParamsButton1.setText(messages.ApplyButton);
		ApplyParamsButton1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2,1));
		SetToDefaultValuesButton1 = new Button(composite, SWT.PUSH);
		SetToDefaultValuesButton1.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, true, false, 1,1));
		SetToDefaultValuesButton1.setText(messages.SetToDefaultButton);
		
		ApplyParamsButton1.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				
				if (validateData(networkSettingsTextList) == false) { // wanText �� �������� � ���� ������
					MessageDialog.openInformation(shell, messages.DialogTitleWarning, messages.DialogWrongNetworkSettings);
				} else {
					if (validateData(ipAddressTrapTextList) == false) {
						MessageDialog.openInformation(shell, messages.DialogTitleWarning, messages.DialogWrongTrapAddresses);	
					} else {
						DialogSelectConnection selectConnection = new DialogSelectConnection();
						if (selectConnection.connectToNewUps() == true) {
							RequestJobS.getInstance().Stop();
							createAndSetRequest();
							getRequest().setNetworkSettingsToConnectToNewUps(getNetworkSettingsFromTexts());
							getRequest().tryConnectToUps();
							if (!getRequest().isFailed()) {	
								getRequest().extractSnmpTrapSettings();
								getRequest().extractUpsParam();
								if (getRequest().getUps().getUpsParams()!=null) {
									if (getRequest().getUps().getUpsParams().getUpsConnectedFlag()!=null) {
										if (getRequest().getUps().getUpsParams().getUpsConnectedFlag() == 1) {
											getRequest().extractPassportSettings();
										}
									}
									getRequest().extractNetworkSettings();
									getRequest().extractPhaseNumber();
									settings.loadValuesFromUps(getRequest().getUps());
								}
								/*getRequest().extractNetworkSettings();
								getRequest().extractPhaseNumber();
								settings.loadValuesFromUps(getRequest().getUps());*/
							} else {
								settings.writeDefaultTrapAddr();
								settings.writeDefaultPassportParams();
							}
							settings.writeWorkingNetworkSettings(getRequest().getUps().getNetworkSettings());
							settings.writeActionComboValues(alarmEventBatteryLow, alarmEventInputLineFail);
							settings.writeSoundSignalizationCombo(soundSignalizationCombo);
							fillTextValuesFromSettings();
							RequestJobS.getInstance().Run();
							return;
						}
						if (selectConnection.writeToThisUps()) {
							createAndSetRequest();
						
							if (!selectConnection.isConnectToLocalIp()) {
								if (!getRequest().getUps().getNetworkSettings().getIpAddress().equals(ipAddressUPSText.getText()) 
										| !getRequest().getUps().getNetworkSettings().getMask().equals(maskText.getText())
										| !getRequest().getUps().getNetworkSettings().getGateway().equals(gatewayText.getText())) {
			
									boolean result = MessageDialog.openQuestion(shell, messages.DialogTitleWarning, messages.DialogConnectonFromOutsideOfNetwork);
									if (!result) {
										fillTextValuesFromSettings();
										return;
									}
								}
							}
							
							settings.read();
							settings.writeActionComboValues(alarmEventBatteryLow, alarmEventInputLineFail);
							settings.writeSoundSignalizationCombo(soundSignalizationCombo);
							createAndSetRequest();
							
							RequestJobS.getInstance().Stop();
							DialogOpenAccess dialogOpenAccess = new DialogOpenAccess();
							dialogOpenAccess.openToGetAccess();
							if (dialogOpenAccess.noConnection()) {
								clearTrapText();
								boolean result = MessageDialog.openQuestion(shell, messages.DialogTitleWarning, messages.DialogNoConnectionSaveLocally);
								switchDialogOpenConfirm(result);
								return;
							}
							
							if (dialogOpenAccess.isClosed()) {
								fillTextValuesFromSettings();
								RequestJobS.getInstance().Run();
								return;
							}
							
							if (dialogOpenAccess.accessIsOpened()) {
								NetworkSettings networkSettings = getNetworkSettingsFromTexts();
								settings.writeWorkingNetworkSettings(networkSettings);
								
								boolean makeDelay = false;
								if (getRequest().getUps().getNetworkSettings().getIpAddress().equals(networkSettings.getIpAddress()) | selectConnection.isConnectToLocalIp() == false) {
									makeDelay = true;
								}
								getRequest().setUpsNetworkSettings(networkSettings);
								getRequest().setSnmpTrapSettings(ipAddressTrapTextList, trapLanguageCombo.getText());
								getRequest().setSnmpCommunities(networkSettings);
								getRequest().closeAccess();
								//settings.writeWorkingNetworkSettings(networkSettings);
								//settings.read();// �� ��������!
								
								if (makeDelay) { // ����� ���? �����, ����� �������� ������ udpSocket.
									try {
										Thread.sleep(3000);
									} catch (InterruptedException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									}
								}
								if (selectConnection.isConnectToLocalIp()) {
									networkSettings.setIpAddressWan(networkSettings.getIpAddress());
									settings.writeWorkingNetworkSettings(networkSettings);
								} 
								//settings.writeWorkingNetworkSettings(networkSettings);
								//createAndSetRequest(networkSettings);
								createAndSetRequest();
								getRequest().tryConnectToUps();		
								//TODO
								getRequest().extractNetworkSettings();
								if (!getRequest().isFailed()) {
									getRequest().extractNetworkSettings();
									getRequest().extractSnmpTrapSettings();
									getRequest().extractPassportSettings();
									getRequest().extractPhaseNumber();
									selectTrapLanguageCombo();
									
									showConfirmDialog(getRequest().getUps());
									settings.loadValuesFromUps(getRequest().getUps());
									
									fillTextValuesFromSettings();
									RequestJobS.getInstance().Run();
									return;
								} else {
									MessageDialog.openInformation(shell, messages.DialogTitleWarning, messages.DialogNoConnectionDataWritten);
									loadValuesFromTextToSettings();
									fillTextValuesFromSettings();
									RequestJobS.getInstance().Run();
									return;
								}
							} else {
								//System.out.println("������ ������");
								boolean result = MessageDialog.openQuestion(shell, messages.DialogTitleWarning, messages.DialogPasswordIncorrectSaveLocally);
								switchDialogOpenConfirm(result);
								return;
							}
						}
						
						return;
					}
				}
			}
		});
		
		SetToDefaultValuesButton1.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				boolean result = MessageDialog.openQuestion(shell, messages.DialogTitleWarning, messages.DialogReturnDefaultSettings);
				if (result) {
					RequestJobS.getInstance().Stop();  //��������!
					settings.writeDefault();
					settings.read();
					//connectFromOutside = false;
					//connectFromOutsideBtn.setSelection(false);
					fillTextValuesFromSettings();
					RequestJobS.getInstance().Run();	
				}
			}
		});
		
		serviceInformation = new Button(composite, SWT.PUSH);
		serviceInformation.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		serviceInformation.setText(messages.ServiceParamsBtn);
		serviceInformation.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				Request request = new Request();
				request.extractServiceParams();
				//System.out.println(request.getUps().getServiceParamsAsString());
				new DialogServiceParams(request.getUps().getServiceParamsAsString());				
			}
		});
		
		startTestButton = new Button(composite, SWT.PUSH);
		startTestButton.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, true, false, 1,1));
		startTestButton.setText(messages.StartTestButtonText);
		startTestButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				 new DialogBatteryTest();
			}
		});
		
		relayButton = new Button(composite, SWT.PUSH);
		relayButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		relayButton.setText(messages.RelayButton);
		relayButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				DialogOpenAccess dialogAccess = new DialogOpenAccess();
				dialogAccess.openToSetControlContacts();
			}
		});
		
		/*Button trapSendButton = new Button(composite, SWT.PUSH);
		trapSendButton.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1,1));
		trapSendButton.setText(" ");
		trapSendButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				//RequestJobS.getInstance().getRequest().getClient().sendTrap(".1.3.6.1.4.1.34498.2.4.2.2", ".1.3.6.1.4.1.34498.2.4.1.1.1.4.1", "", "192.168.0.63", 162);
				//System.out.println(new String(Request.convertAsciiToString("D2:E5:F1:F2")));
				//Toolkit.getDefaultToolkit().beep();
				//ava.awt.Toolkit.getDefaultToolkit().beep();
				 //com.pyx4j.jni.Beep.beep(37, 200);
				 //com.pyx4j.jni.Beep.beep(1000, 200);
				//SoundClass.pcSpeakerBeep();
				//System.out.println(System.getProperty("java.library.path"));
				DialogControlContactsLinux dialog = new DialogControlContactsLinux("1111");
				
			}
		});*/
		
		composite.pack();
		partHeight = partHeight + composite.getBounds().height;
	}
	
	//TODO
	/*private Boolean validateWanAddress() {
		Boolean result = false;
		InetAddress ipAddress;
		try {
			ipAddress = InetAddress.getByName(ipAddressWanText.getText());
			wanIpAddress = ipAddress.getHostAddress();
		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			wanIpAddress = null;
			//e.printStackTrace();
			result = false;
		}
		return result;
	     // System.out.println("IP address: " + ipaddress.getHostAddress());
	}*/

	private void showConfirmDialog(Ups ups) {
		String string = "";
		string = messages.DialogConfirmWrittenSettings + "\n";
		string = string +"\n";
		string = string + messages.ipAddressLabel + " " + ups.getNetworkSettings().getIpAddress()+"\n";
		string = string + messages.MaskLabel + " " + ups.getNetworkSettings().getMask()+"\n";
		string = string + messages.GatewayLabel + " " + ups.getNetworkSettings().getGateway()+"\n";
		string = string +"\n";
		string = string + "Community read: " + ups.getNetworkSettings().getCommunityRead()+"\n";
		string = string + "Community write: " + ups.getNetworkSettings().getCommunityWrite()+"\n";
		string = string +"\n";
		
		string = string + messages.trapRecievers + "\n";
		for (int i=0;i<ups.getSnmpTrapSettings().getTrapRecievers().size();i++) {
			string = string + messages.trapAddress + (i+1) + " : " + ups.getSnmpTrapSettings().getTrapRecievers().get(i)+"\n";
			ipAddressTrapTextList.get(i).setText(ups.getSnmpTrapSettings().getTrapRecievers().get(i));
		}
		string = string +"\n";
		string = string + messages.trapLanguage + ups.getSnmpTrapSettings().getLanguage();
		MessageDialog.openInformation(shell, messages.DialogTitleWarning, string);
	}
	
	private NetworkSettings getNetworkSettingsFromTexts() {
		NetworkSettings networkSettings = new NetworkSettings();
		networkSettings.setIpAddress(ipAddressUPSText.getText());
		//TODO
		//networkSettings.setIpAddressWan(wanIpAddress);
		networkSettings.setIpAddressWan(ipAddressWanText.getText());
		networkSettings.setMask(maskText.getText());
		networkSettings.setGateway(gatewayText.getText());
		networkSettings.setPort(portText.getText());
		networkSettings.setCommunityRead(communityReadText.getText());
		networkSettings.setCommunityWrite(communityWriteText.getText());
		return networkSettings;
	}
	
	private void createAndSetRequest() { //settings from disk
		this.request = new Request();
	}
	
	private void createAndSetRequest(NetworkSettings networkSettings) { 
		this.request = new Request(networkSettings);
	}
	
	private Request getRequest(){
		return request;
	}
	
	private void switchDialogOpenConfirm( Boolean result) {
		if (result) {
			loadValuesFromTextToSettings();
			settings.writeDefaultTrapAddr();
			settings.writeDefaultPassportParams();
			fillTextValuesFromSettings();
		} else {
			fillTextValuesFromSettings();
		}
		RequestJobS.getInstance().Run();
	}
	
	private void loadValuesFromTextToSettings() {
		settings.ipAddressUPS = ipAddressUPSText.getText();
		//TODO
		settings.ipAddressUPSWan = ipAddressWanText.getText();
		//settings.ipAddressUPSWan = wanIpAddress;
		settings.mask =  maskText.getText();
		settings.gateway = gatewayText.getText();
		settings.port = portText.getText();
		settings.communityRead = communityReadText.getText();
		settings.communityWrite = communityWriteText.getText();
		settings.onBatteryLowEvent = Integer.toString(alarmEventBatteryLow.getSelectionIndex());
		settings.onInputLineFailEvent = Integer.toString(alarmEventInputLineFail.getSelectionIndex());
		settings.ipAddressTrap1 = ipAddressTrap1Text.getText();
		settings.ipAddressTrap2 = ipAddressTrap2Text.getText();
		settings.ipAddressTrap3 = ipAddressTrap3Text.getText();
		settings.ipAddressTrap4 = ipAddressTrap4Text.getText();
		settings.trapLanguage = Integer.toString(trapLanguageCombo.getSelectionIndex());
		settings.write();
		settings.read();
	}
		
	private void clearTrapText(){
		for (int i = 0; i < ipAddressTrapTextList.size(); i++) {
			ipAddressTrapTextList.get(i).setText("");
		}
	}
	
	/*public void getTrapLanguageAndSelectCombo(Request request) {
		String language = request.getUps().getSnmpTrapSettings().getLanguage();
		if (language != null) {
			if (language.equals("EN")){
				trapLanguageCombo.select(0);
			}
			if (language.equals("RU")){
				trapLanguageCombo.select(1);
			}
		}
	}*/
	
	public void selectTrapLanguageCombo() {
		try {
			if (getRequest().getUps().getSnmpTrapSettings()!= null) {
				String language = getRequest().getUps().getSnmpTrapSettings().getLanguage();
				if (language != null) {
					if (language.equals("EN")){
						trapLanguageCombo.select(0);
					}
					if (language.equals("RU")){
						trapLanguageCombo.select(1);
					}
				}
			}
		} catch (Exception e) {
			
		}
	}
	
	public void fillNetworkTextValuesFromSettings() {
		settings.read();
		ipAddressUPSText.setText(settings.ipAddressUPS);
		ipAddressWanText.setText(settings.ipAddressUPSWan);
		maskText.setText(settings.mask);
		gatewayText.setText(settings.gateway);
	}
	
	public void fillTrapTextValuesFromSettings() {
		settings.read();
		ipAddressTrap1Text.setText(settings.ipAddressTrap1);
		ipAddressTrap2Text.setText(settings.ipAddressTrap2);
		ipAddressTrap3Text.setText(settings.ipAddressTrap3);
		ipAddressTrap4Text.setText(settings.ipAddressTrap4);
	}
	
	public void fillTextValuesFromSettings() {
		try {
			settings.read();
			ipAddressUPSText.setText(settings.ipAddressUPS);
			ipAddressWanText.setText(settings.ipAddressUPSWan);
			maskText.setText(settings.mask);
			gatewayText.setText(settings.gateway);
			communityWriteText.setText(settings.communityWrite);
			portText.setText(settings.port);
			communityReadText.setText(settings.communityRead);
			communityWriteText.setText(settings.communityWrite);
			alarmEventBatteryLow.select(Integer.parseInt(settings.onBatteryLowEvent));
			alarmEventInputLineFail.select(Integer.parseInt(settings.onInputLineFailEvent));
			ipAddressTrap1Text.setText(settings.ipAddressTrap1);
			ipAddressTrap2Text.setText(settings.ipAddressTrap2);
			ipAddressTrap3Text.setText(settings.ipAddressTrap3);
			ipAddressTrap4Text.setText(settings.ipAddressTrap4);
			trapLanguageCombo.select(Integer.parseInt(settings.trapLanguage));
			try {
				systemLanguageCombo.select(Integer.parseInt(settings.systemLanguage));
			} catch (Exception e) {
				
			}
			
			try {
				soundSignalizationCombo.select(Integer.parseInt(settings.soundSignalization));
			} catch (Exception e) {
				
			}
		} catch(Exception e) {
			
		}
	}
	
	private GridData getGridData() {
		GridData gridData = new GridData();
		gridData = new GridData(SWT.FILL, SWT.FILL, true, false);
		gridData.horizontalSpan= 2;
		gridData.minimumWidth = 500-50;
		return gridData;
	}
	
	private GridData getGridDataText() {
		GridData gridData = new GridData();
		gridData.horizontalAlignment = GridData.FILL;
		gridData.grabExcessHorizontalSpace = true;
		return gridData;
	}
	
	private GridLayout getGridLayout() {
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 2;
		return gridLayout;
		
	}
	
	@PreDestroy
	public void dispose() {
		
	}
	
	@Focus
	private void setFocus() {
		try {
			fillTextValuesFromSettings();
		}catch(Exception e){
			
		}
	}
	
	private static final String PATTERN = 
	        "^([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\." +
	        "([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\." +
	        "([01]?\\d\\d?|2[0-4]\\d|25[0-5])\\." +
	        "([01]?\\d\\d?|2[0-4]\\d|25[0-5])$";

	public static boolean validate(final String ip) {          
		Boolean result = false;
	      Pattern pattern = Pattern.compile(PATTERN);
	      /*if (ip == "") {
	    	  result = true;
	      }*/
	      if (ip.equals("n/a") | ip.equals("")) {
	    	  result = true;
	      } else {
	    	  Matcher matcher = pattern.matcher(ip);
	    	  result = matcher.matches();
	      }
	      return result;             
	}
	
	public boolean validateData(List<Text> list) {
		Boolean result = true;
		if (list != null) {
			for (int i = 0; i < list.size(); i++) {
				if (validate(list.get(i).getText()) == false) {
					fillNetworkTextValuesFromSettings();
					fillTrapTextValuesFromSettings();
					result = false;
				}
			}
		} else {
			result = false;
			fillNetworkTextValuesFromSettings();
			fillTrapTextValuesFromSettings();
		}
		
		  
		return result;
	}
	
	private void setButtons(Boolean flag) {
		getRelayButton().setEnabled(flag);
		getStartTestButton().setEnabled(flag);
		getChangePasswordBtn().setEnabled(flag);
		getServiceInformationBtn().setEnabled(flag);
	}
	
	@Inject @Optional
	public void SetButtonsDisabled(@EventTopic(EventConstants.NO_CONNECTION) UpsParam upsParams) {
		setButtons(false);
	}
	
	@Inject @Optional
	public void SetButtonsEnabled(@EventTopic(EventConstants.CONNECTION_OK) UpsParam upsParams) {
		if (upsParams != null) {
			if (upsParams.getUpsConnectedFlag() == 0) {
				setButtons(false);
				return;
			}
		}
		setButtons(true);
	}

	@Inject @Optional
	public void HandlerRefreshLabels(@UIEventTopic(EventConstants.SETTINGS_VIEW_REFRESH_LABELS) final String go) {
		fillTextValuesFromSettings();
	}
	
	@Inject @Optional
	public void HandlerGetTrapAndPassportParam(@UIEventTopic(EventConstants.GET_TRAP_AND_PASSPORT_PARAMS) Request request) {
		//getTrapAndPassportParamsAndLoadToSettingsFile();
		settings.loadValuesFromUps(request.getUps());
		fillTextValuesFromSettings();
		//System.out.println("RefreshFromSettingsView");
	}
	
	public Button getRelayButton() {
		return relayButton;
	}

	public Button getStartTestButton() {
		return startTestButton;
	}

	public Button getChangePasswordBtn() {
		return changePassword;
	}

	public Button getServiceInformationBtn() {
		return serviceInformation;
	}

	@Inject
	  public void translate(@Translation Messages messages) {		
		try {	
			SystemSettingsgroup.setText(messages.SystemSettingsGroup);
			onBatteryLow.setText(messages.OnBatteryLowLabel);
			alarmEventBatteryLow.setItems(new String[] { messages.AlarmEventComboShutdownPC, messages.AlarmEventComboHybernate, messages.AlarmEventComboNone});
			onInpitLineFail.setText(messages.OnInputLineFailLabel);
			alarmEventInputLineFail.setItems(new String[] { messages.AlarmEventComboShutdownPC, messages.AlarmEventComboHybernate, messages.AlarmEventComboNone});
			systemLanguage.setText(messages.systemLanguageCombo);
			
			connectionSettingsgroup.setText(messages.SnmpAccessGroup);
			ipAddressWanLbl.setText(messages.AddressLabel);
			port.setText(messages.PortLabel);
			communityWrite.setText(messages.CommunityWriteLabel);
			changePassword.setText(messages.ChangePasswordBtn);
			communityRead.setText(messages.CommunityReadLabel);
			
			UpsSettingsGroup.setText(messages.SnmpSettingsGroup);
			ipAddressUPS.setText(messages.ipAddressLabel);
			mask.setText(messages.MaskLabel);
			gateway.setText(messages.GatewayLabel);
			
			TrapSettingsGroup.setText(messages.TrapSettingsGroup);
			ipAddressTrap1.setText(messages.ipAddressTrap1);
			ipAddressTrap2.setText(messages.ipAddressTrap2);
			ipAddressTrap3.setText(messages.ipAddressTrap3);
			ipAddressTrap4.setText(messages.ipAddressTrap4);
			trapLanguage.setText(messages.trapLanguage);
			
			ApplyParamsButton1.setText(messages.ApplyButton);
			SetToDefaultValuesButton1.setText(messages.SetToDefaultButton);
			serviceInformation.setText(messages.ServiceParamsBtn); 
			startTestButton.setText(messages.StartTestButtonText);
			relayButton.setText(messages.RelayButton);
			
			soundSignalization.setText(messages.soundSignalization);
			soundSignalizationCombo.setItems(new String[] { messages.ComboSoundSignalizationDisabled, messages.ComboSoundSignalizationExternalSpeakers}); 
			
			
		} catch (Exception e) {
			
		}
	}	
}
