package s.d.manager.views;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import org.eclipse.e4.core.di.annotations.Optional;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.core.services.nls.Translation;
import org.eclipse.e4.ui.di.UIEventTopic;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import s.d.manager.model.EventConstants;


public class ToolItem {
	
	private Label labelStatus;
	private Label labelStatusValue;
	private Label labelAlarmValue;
	@Inject IEventBroker broker;
	@Inject @Translation Messages messages;
	Composite parent;
	private Label labelAlarmInputLineValue;
	
	@PostConstruct
	  public void createControls(Composite parent) {
	    this.parent = parent;
	    RowLayout layout = new RowLayout();
	    parent.setLayout(layout);
	    labelStatus = new Label(parent, SWT.NONE);
	    labelStatus.setText(messages.ToolItemInquery);
	    labelStatusValue = new Label(parent, SWT.NONE);
	    Label separator = new Label(parent, SWT.SEPARATOR | SWT.VERTICAL);
	    separator.setLayoutData(new RowData(5, 15));
	    labelAlarmValue = new Label(parent, SWT.NONE);
	    Label separator1 = new Label(parent, SWT.SEPARATOR | SWT.VERTICAL);
	    separator1.setLayoutData(new RowData(5, 15));
	    labelAlarmInputLineValue =  new Label(parent, SWT.NONE);
	    parent.pack();
	}
	
	public void setStatus(String s) {
		try{
			labelStatusValue.setText(s);
			labelStatusValue.pack();
			parent.pack();
			
		}catch (Exception e){
			
		}
	}
	
	public void setAlarm(String s){
		try{
			//labelAlarmValue.setText(s);
			labelAlarmValue.setText(s);	
			labelAlarmValue.pack();
			parent.pack();
			setLabelColor(labelAlarmValue, SWT.COLOR_RED);
		}catch (Exception e){
		
		}
	}
	
	public void setAlarmInputLine(String s){
		try{
			//labelAlarmValue.setText(s);
			labelAlarmInputLineValue.setText(s);	
			labelAlarmInputLineValue.pack();
			parent.pack();
			setLabelColor(labelAlarmInputLineValue, SWT.COLOR_RED);
		}catch (Exception e){
		
		}
	}
	
	@Inject
	@Optional
	public void HandlerAlarm(@UIEventTopic(EventConstants.TOOLITEM_ALARM) String s) {
	  setAlarm(s);
	  
	} 

	@Inject
	@Optional
	public void HandlerAlarmInputLine(@UIEventTopic(EventConstants.TOOLITEM_ALARM_INPUT_LINE) String value) {
		setAlarmInputLine(value);
		//Application.getInstance().logger.info(value);
	} 
	
	@Inject
	@Optional
	public void HandlerStaus(@UIEventTopic(EventConstants.TOOLITEM_STATUS) String value) {
	  setStatus(value);
	  //s.d.manager.model.Application.getInstance().logger.info(value);
	  
	}

	public void setLabelColor(final Label label, final Integer color){
		try{
			Display.getDefault().asyncExec(new Runnable() {
		          public void run() {
		        	  label.setForeground(Display.getDefault().getSystemColor(color));
		        	  label.pack();		        	  
		          }
			});
		}catch (Exception e){
			
		}
				
	}
	@Inject
	  public void translate(@Translation Messages messages) {		
		try {
			labelStatus.setText(messages.ToolItemInquery);
		} catch (Exception e) {
			
		}
	}
}
