package s.d.manager.views;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.PostConstruct;

import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

import s.d.manager.model.Request;
import s.d.manager.model.ups.NetworkSettings;
import s.d.manager.model.ups.Relay;

public class TuningPart {

	@PostConstruct
	public void createControls(final Composite parent1, final MPart part) {

		parent1.setLayout(new GridLayout(1, false));
		parent1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		
		/*final ScrolledComposite sc = new ScrolledComposite(parent1, SWT.V_SCROLL);
		
		final Composite composite = new Composite(sc, SWT.NONE);
		
	    sc.setContent(composite);  
	    sc.setLayout(new GridLayout(1, false));
		sc.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		sc.setExpandHorizontal(true);
		
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));*/
		
		createTuningGroup(parent1);
		//composite.pack();
		parent1.pack();
	}

	public void createTuningGroup(Composite parent) {
		
		final Composite composite = new Composite(parent, SWT.NONE);
		//composite.setLayout(new GridLayout(1, false));
		composite.setLayout(parent.getLayout());
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		final Text mainText = new Text(composite, SWT.MULTI | SWT.BORDER);
		mainText.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		Button startButton = new Button(composite, SWT.PUSH);
		startButton.setText("");
		startButton.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, true, false, 2, 1));
		
		startButton.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				//Application.showAlarmDialogs = false;
				mainText.setText("");
				MessageDialog.openInformation(composite.getShell(), "!",
						"    ,     10.     .");
				//if (result == true) {
					
					NetworkSettings nsDefault = new NetworkSettings();
					nsDefault.setIpAddress("192.168.0.1");
					nsDefault.setPort("161");
					nsDefault.setIpAddressWan("192.168.0.1");
					nsDefault.setMask("255.255.255.0");
					nsDefault.setCommunityRead("public");
					nsDefault.setCommunityWrite("public");
					nsDefault.setGateway("192.168.0.100");
					
					Request request = new Request(nsDefault);
					//request.setUps(ups);
					mainText.insert("     ... \n");
					request.extractUpsParam();
					if (request.getUps().getUpsParams() != null) {
						mainText.insert("  \n");
						if (request.getUps().getUpsParams().getUpsConnectedFlag() == 1) {
							mainText.insert("Snmp-    \n");
							request.setPasswordToWork("1111");
							mainText.insert("   : 1111 \n");
							if (request.openAccess() == true) {
								mainText.insert("  \n");
								List<Relay> relaysNew = new ArrayList<Relay>();
	
								relaysNew.add(new Relay(2,0)); //   , /
								//relaysNew.add(new Relay(7,0)); //  , /
								relaysNew.add(new Relay(5,0)); // , /
								//relaysNew.add(new Relay(2,0)); //   , /
								request.setRelaysValues(relaysNew);
								
								mainText.insert("    \n");
								
								request.closeAccess();
								mainText.insert("  \n");
								MessageDialog.openInformation( composite.getShell(), "!", "     .    -   .     -   .");
					
								NetworkSettings nsNew = new NetworkSettings();
								nsNew.setIpAddress("192.168.0.5");
								nsNew.setIpAddressWan("192.168.0.5");
								nsNew.setPort("161");
								nsNew.setMask("255.255.255.0");
								nsNew.setCommunityRead("public1");
								nsNew.setCommunityWrite("public2");
								nsNew.setGateway("192.168.0.100");
								
								mainText.insert("  \n");
								
								if (request.openAccess( )== true) {
									mainText.insert("  \n");
									
									request.setUpsNetworkSettings(nsNew);
									request.setSnmpCommunities(nsNew);
									mainText.insert("   \n");
									mainText.insert("ip = 192.168.0.5 \n");
									mainText.insert("mask = 255.255.255.0 \n");
									mainText.insert("gateway = 192.168.0.100 \n");
									mainText.insert("community read = public1 \n");
									mainText.insert("community write = public2 \n");
									request.closeAccess();
									
									mainText.insert("  \n");
								
									Request request2 = new Request(nsNew);
									mainText.insert("       \n");
									request2.tryConnectToUps();
									if (!request2.isFailed()) {
										mainText.insert("    ip 192.168.0.5  \n");
										MessageDialog.openInformation( composite.getShell(), "!", "     ,     10.     :  ");
										nsDefault.setCommunityRead("public");
										nsDefault.setCommunityWrite("public");
										Request request3 = new Request(nsDefault);
										request3.extractNetworkSettings();
										if (request3.getUps().getNetworkSettings() != null) {
											mainText.insert("    ip 192.168.0.1  \n");
											Boolean failed = false;
											if (!nsDefault.getIpAddress().equals(request3.getUps().getNetworkSettings().getIpAddress())) {
												failed = true;
											}
											if (!nsDefault.getMask().equals(request3.getUps().getNetworkSettings().getMask())) {
												failed = true;
											}
											if (!nsDefault.getGateway().equals(request3.getUps().getNetworkSettings().getGateway())) {
												failed = true;
											}
											if (!nsDefault.getCommunityRead().equals(request3.getUps().getNetworkSettings().getCommunityRead())) {
												failed = true;
											}
											if (!nsDefault.getCommunityWrite().equals(request3.getUps().getNetworkSettings().getCommunityWrite())) {
												failed = true;
											}
											
											if (!failed) {
												String string = "";
												string = string + "ip = " + request3.getUps().getNetworkSettings().getIpAddress() + "\n";
												string = string + "mask = " + request3.getUps().getNetworkSettings().getMask() + "\n";
												string = string + "gateway = " + request3.getUps().getNetworkSettings().getGateway() + "\n";
												string = string + "community read = " + request3.getUps().getNetworkSettings().getCommunityRead() + "\n";
												string = string + "community write = " + request3.getUps().getNetworkSettings().getCommunityWrite() + "\n";
												mainText.insert("  . \n");
												MessageDialog.openInformation(composite.getShell(), "!", "  !    : \n" + string);
												//Application.showAlarmDialogs = true;	
												return;
											} else {
												//Application.showAlarmDialogs = true;	
												mainText.insert("  .           \n");
												MessageDialog.openError(composite.getShell(), "!", "  !          .");
												return;
											}
										} else {
											//Application.showAlarmDialogs = true;	
											mainText.insert("  .     \n");
											MessageDialog.openError(composite.getShell(), "!", "  !    !");
											return;
										}
									} else {
										//Application.showAlarmDialogs = true;	
										mainText.insert("  ");
										MessageDialog.openError(composite.getShell(), "!", "   !");
										return;
									}
								} else {
									//Application.showAlarmDialogs = true;	
									mainText.insert(" ");
									MessageDialog.openError(composite.getShell(), "!", "    .      .");
									return;	
								}
							} else {
								//Application.showAlarmDialogs = true;	
								mainText.insert(" ");
								MessageDialog.openError(composite.getShell(), "!", "    .      .");
								return;
							}
							
						} else {
							//Application.showAlarmDialogs = true;	 
							mainText.insert("Snmp-    .  . \n");
							MessageDialog.openError(composite.getShell(), "!", "  snmp-  !  .");
							return;
						}
						
					} else {
						//Application.showAlarmDialogs = true;	
						mainText.insert("   \n");
						
						MessageDialog.openError(composite.getShell(), "", "   !");
						return;
					}
			}
			
		});

		composite.pack();
	}
}

